/* FileWatcher.c generated by valac 0.56.16, the Vala compiler
 * generated from FileWatcher.vala, do not modify */

/* Copyright 2017 Go For It! developers
*
* This file is part of Go For It!.
*
* Go For It! is free software: you can redistribute it
* and/or modify it under the terms of version 3 of the
* GNU General Public License as published by the Free Software Foundation.
*
* Go For It! is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with Go For It!. If not, see http://www.gnu.org/licenses/.
*/

#include "com.github.jmoerman.go-for-it-0.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecFileWatcher ParamSpecFileWatcher;
enum  {
	FILE_WATCHER_CHANGED_SIGNAL,
	FILE_WATCHER_NUM_SIGNALS
};
static guint file_watcher_signals[FILE_WATCHER_NUM_SIGNALS] = {0};

struct _FileWatcherPrivate {
	GFileMonitor* monitor;
	gchar* etag;
	gboolean changed_received;
	gboolean _watching;
	gboolean _being_updated;
	GFile* _file;
};

struct _ParamSpecFileWatcher {
	GParamSpec parent_instance;
};

static gint FileWatcher_private_offset;
static gpointer file_watcher_parent_class = NULL;

static void file_watcher_set_being_updated (FileWatcher* self,
                                     gboolean value);
static void file_watcher_on_file_changed (FileWatcher* self);
static void _file_watcher_on_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                           GFile* file,
                                                           GFile* other_file,
                                                           GFileMonitorEvent event_type,
                                                           gpointer self);
static gchar* file_watcher_get_etag (FileWatcher* self);
static gboolean file_watcher_update_etag (FileWatcher* self);
static gboolean file_watcher_emit_signal_if_changed (FileWatcher* self);
static gboolean _file_watcher_emit_signal_if_changed_gsource_func (gpointer self);
static void file_watcher_finalize (FileWatcher * obj);
static GType file_watcher_get_type_once (void);

static inline gpointer
file_watcher_get_instance_private (FileWatcher* self)
{
	return G_STRUCT_MEMBER_P (self, FileWatcher_private_offset);
}

static void
_file_watcher_on_file_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                      GFile* file,
                                                      GFile* other_file,
                                                      GFileMonitorEvent event_type,
                                                      gpointer self)
{
#line 68 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	file_watcher_on_file_changed ((FileWatcher*) self);
#line 95 "FileWatcher.c"
}

FileWatcher*
file_watcher_construct (GType object_type,
                        GFile* file)
{
	FileWatcher* self = NULL;
	gchar* _tmp0_;
	GFileMonitor* _tmp1_;
#line 62 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 62 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	self = (FileWatcher*) g_type_create_instance (object_type);
#line 63 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_tmp0_ = g_strdup ("");
#line 63 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_g_free0 (self->priv->etag);
#line 63 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	self->priv->etag = _tmp0_;
#line 64 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	file_watcher_set_file (self, file);
#line 65 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	file_watcher_set_being_updated (self, FALSE);
#line 66 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	file_watcher_set_watching (self, TRUE);
#line 68 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_tmp1_ = self->priv->monitor;
#line 68 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_signal_connect (_tmp1_, "changed", (GCallback) _file_watcher_on_file_changed_g_file_monitor_changed, self);
#line 62 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return self;
#line 127 "FileWatcher.c"
}

FileWatcher*
file_watcher_new (GFile* file)
{
#line 62 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return file_watcher_construct (TYPE_FILE_WATCHER, file);
#line 135 "FileWatcher.c"
}

static gchar*
file_watcher_get_etag (FileWatcher* self)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 71 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "FileWatcher.c"
	{
		GFileInfo* file_info = NULL;
		GFileInfo* _tmp0_ = NULL;
		GFile* _tmp1_;
		GFileInfo* _tmp2_;
		GFileInfo* _tmp3_;
		GFileInfo* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 74 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp1_ = self->priv->_file;
#line 74 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp2_ = g_file_query_info (_tmp1_, G_FILE_ATTRIBUTE_ETAG_VALUE, 0, NULL, &_inner_error0_);
#line 74 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp0_ = _tmp2_;
#line 74 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
			_g_object_unref0 (file_info);
#line 165 "FileWatcher.c"
			goto __catch0_g_error;
		}
#line 74 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp3_ = _tmp0_;
#line 74 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp0_ = NULL;
#line 74 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_g_object_unref0 (file_info);
#line 74 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		file_info = _tmp3_;
#line 75 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp4_ = file_info;
#line 75 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp5_ = g_file_info_get_etag (_tmp4_);
#line 75 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 75 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		result = _tmp6_;
#line 75 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_g_object_unref0 (_tmp0_);
#line 75 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_g_object_unref0 (file_info);
#line 75 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		return result;
#line 190 "FileWatcher.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 72 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		e = _inner_error0_;
#line 72 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_inner_error0_ = NULL;
#line 77 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp7_ = e;
#line 77 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp8_ = _tmp7_->message;
#line 77 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		g_warning ("FileWatcher.vala:77: %s", _tmp8_);
#line 78 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp9_ = g_strdup ("");
#line 78 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		result = _tmp9_;
#line 78 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_g_error_free0 (e);
#line 78 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		return result;
#line 217 "FileWatcher.c"
	}
	__finally0:
#line 72 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 72 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_clear_error (&_inner_error0_);
#line 72 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return NULL;
#line 226 "FileWatcher.c"
}

static gboolean
file_watcher_update_etag (FileWatcher* self)
{
	gchar* new_etag = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 82 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_tmp0_ = file_watcher_get_etag (self);
#line 83 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	new_etag = _tmp0_;
#line 84 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_tmp1_ = new_etag;
#line 84 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_tmp2_ = self->priv->etag;
#line 84 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (g_strcmp0 (_tmp1_, _tmp2_) != 0) {
#line 249 "FileWatcher.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 85 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp3_ = new_etag;
#line 85 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 85 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_g_free0 (self->priv->etag);
#line 85 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		self->priv->etag = _tmp4_;
#line 86 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		result = TRUE;
#line 86 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_g_free0 (new_etag);
#line 86 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		return result;
#line 266 "FileWatcher.c"
	}
#line 88 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	result = FALSE;
#line 88 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_g_free0 (new_etag);
#line 88 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return result;
#line 274 "FileWatcher.c"
}

static gboolean
_file_watcher_emit_signal_if_changed_gsource_func (gpointer self)
{
	gboolean result;
	result = file_watcher_emit_signal_if_changed ((FileWatcher*) self);
#line 100 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return result;
#line 284 "FileWatcher.c"
}

static void
file_watcher_on_file_changed (FileWatcher* self)
{
	gboolean _tmp0_;
#line 91 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_if_fail (self != NULL);
#line 92 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (!self->priv->_watching) {
#line 93 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		return;
#line 297 "FileWatcher.c"
	}
#line 95 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_tmp0_ = self->priv->_being_updated;
#line 95 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (_tmp0_) {
#line 96 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		self->priv->changed_received = TRUE;
#line 305 "FileWatcher.c"
	} else {
#line 98 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		file_watcher_set_being_updated (self, TRUE);
#line 100 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT_IDLE, (guint) 100, _file_watcher_emit_signal_if_changed_gsource_func, file_watcher_ref (self), file_watcher_unref);
#line 311 "FileWatcher.c"
	}
}

static gboolean
file_watcher_emit_signal_if_changed (FileWatcher* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 106 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 107 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (self->priv->changed_received) {
#line 108 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		self->priv->changed_received = FALSE;
#line 109 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		result = TRUE;
#line 109 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		return result;
#line 332 "FileWatcher.c"
	}
#line 111 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_tmp1_ = file_watcher_get_watching (self);
#line 111 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_tmp2_ = _tmp1_;
#line 111 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (_tmp2_) {
#line 111 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp0_ = file_watcher_update_etag (self);
#line 342 "FileWatcher.c"
	} else {
#line 111 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp0_ = FALSE;
#line 346 "FileWatcher.c"
	}
#line 111 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (_tmp0_) {
#line 112 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		g_signal_emit (self, file_watcher_signals[FILE_WATCHER_CHANGED_SIGNAL], 0);
#line 352 "FileWatcher.c"
	}
#line 115 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	file_watcher_set_being_updated (self, FALSE);
#line 117 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	result = FALSE;
#line 117 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return result;
#line 360 "FileWatcher.c"
}

gboolean
file_watcher_get_watching (FileWatcher* self)
{
	gboolean result;
#line 33 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	result = self->priv->_watching;
#line 34 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return result;
#line 373 "FileWatcher.c"
}

void
file_watcher_set_watching (FileWatcher* self,
                           gboolean value)
{
#line 29 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_if_fail (self != NULL);
#line 30 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	self->priv->_watching = value;
#line 31 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	file_watcher_update_etag (self);
#line 386 "FileWatcher.c"
}

gboolean
file_watcher_get_being_updated (FileWatcher* self)
{
	gboolean result;
#line 40 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	result = self->priv->_being_updated;
#line 40 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return result;
#line 399 "FileWatcher.c"
}

static void
file_watcher_set_being_updated (FileWatcher* self,
                                gboolean value)
{
#line 41 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_if_fail (self != NULL);
#line 41 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	self->priv->_being_updated = value;
#line 410 "FileWatcher.c"
}

GFile*
file_watcher_get_file (FileWatcher* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 54 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_tmp0_ = self->priv->_file;
#line 55 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	result = _tmp0_;
#line 55 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return result;
#line 426 "FileWatcher.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 46 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 434 "FileWatcher.c"
}

void
file_watcher_set_file (FileWatcher* self,
                       GFile* value)
{
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 45 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_if_fail (self != NULL);
#line 46 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 46 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_g_object_unref0 (self->priv->_file);
#line 46 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	self->priv->_file = _tmp0_;
#line 451 "FileWatcher.c"
	{
		GFileMonitor* _tmp1_ = NULL;
		GFile* _tmp2_;
		GFileMonitor* _tmp3_;
		GFileMonitor* _tmp4_;
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp2_ = self->priv->_file;
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp3_ = g_file_monitor_file (_tmp2_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp1_ = _tmp3_;
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 467 "FileWatcher.c"
				goto __catch0_g_io_error;
			}
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
			g_clear_error (&_inner_error0_);
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
			return;
#line 476 "FileWatcher.c"
		}
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp4_ = _tmp1_;
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp1_ = NULL;
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_g_object_unref0 (self->priv->monitor);
#line 48 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		self->priv->monitor = _tmp4_;
#line 49 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		file_watcher_update_etag (self);
#line 47 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_g_object_unref0 (_tmp1_);
#line 490 "FileWatcher.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 47 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		e = _inner_error0_;
#line 47 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_inner_error0_ = NULL;
#line 51 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp5_ = e;
#line 51 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_tmp6_ = _tmp5_->message;
#line 51 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		g_warning ("FileWatcher.vala:51: %s", _tmp6_);
#line 47 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		_g_error_free0 (e);
#line 510 "FileWatcher.c"
	}
	__finally0:
#line 47 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 47 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 47 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		g_clear_error (&_inner_error0_);
#line 47 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		return;
#line 521 "FileWatcher.c"
	}
}

static void
value_file_watcher_init (GValue* value)
{
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	value->data[0].v_pointer = NULL;
#line 530 "FileWatcher.c"
}

static void
value_file_watcher_free_value (GValue* value)
{
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (value->data[0].v_pointer) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		file_watcher_unref (value->data[0].v_pointer);
#line 540 "FileWatcher.c"
	}
}

static void
value_file_watcher_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (src_value->data[0].v_pointer) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		dest_value->data[0].v_pointer = file_watcher_ref (src_value->data[0].v_pointer);
#line 552 "FileWatcher.c"
	} else {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		dest_value->data[0].v_pointer = NULL;
#line 556 "FileWatcher.c"
	}
}

static gpointer
value_file_watcher_peek_pointer (const GValue* value)
{
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return value->data[0].v_pointer;
#line 565 "FileWatcher.c"
}

static gchar*
value_file_watcher_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (collect_values[0].v_pointer) {
#line 576 "FileWatcher.c"
		FileWatcher * object;
		object = collect_values[0].v_pointer;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		if (object->parent_instance.g_class == NULL) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 583 "FileWatcher.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 587 "FileWatcher.c"
		}
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		value->data[0].v_pointer = file_watcher_ref (object);
#line 591 "FileWatcher.c"
	} else {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		value->data[0].v_pointer = NULL;
#line 595 "FileWatcher.c"
	}
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return NULL;
#line 599 "FileWatcher.c"
}

static gchar*
value_file_watcher_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	FileWatcher ** object_p;
	object_p = collect_values[0].v_pointer;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (!object_p) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 614 "FileWatcher.c"
	}
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (!value->data[0].v_pointer) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		*object_p = NULL;
#line 620 "FileWatcher.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		*object_p = value->data[0].v_pointer;
#line 624 "FileWatcher.c"
	} else {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		*object_p = file_watcher_ref (value->data[0].v_pointer);
#line 628 "FileWatcher.c"
	}
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return NULL;
#line 632 "FileWatcher.c"
}

GParamSpec*
param_spec_file_watcher (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecFileWatcher* spec;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_FILE_WATCHER), NULL);
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return G_PARAM_SPEC (spec);
#line 651 "FileWatcher.c"
}

gpointer
value_get_file_watcher (const GValue* value)
{
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILE_WATCHER), NULL);
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return value->data[0].v_pointer;
#line 661 "FileWatcher.c"
}

void
value_set_file_watcher (GValue* value,
                        gpointer v_object)
{
	FileWatcher * old;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILE_WATCHER));
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	old = value->data[0].v_pointer;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (v_object) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FILE_WATCHER));
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		value->data[0].v_pointer = v_object;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		file_watcher_ref (value->data[0].v_pointer);
#line 683 "FileWatcher.c"
	} else {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		value->data[0].v_pointer = NULL;
#line 687 "FileWatcher.c"
	}
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (old) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		file_watcher_unref (old);
#line 693 "FileWatcher.c"
	}
}

void
value_take_file_watcher (GValue* value,
                         gpointer v_object)
{
	FileWatcher * old;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILE_WATCHER));
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	old = value->data[0].v_pointer;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (v_object) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FILE_WATCHER));
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		value->data[0].v_pointer = v_object;
#line 714 "FileWatcher.c"
	} else {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		value->data[0].v_pointer = NULL;
#line 718 "FileWatcher.c"
	}
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (old) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		file_watcher_unref (old);
#line 724 "FileWatcher.c"
	}
}

static void
file_watcher_class_init (FileWatcherClass * klass,
                         gpointer klass_data)
{
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	file_watcher_parent_class = g_type_class_peek_parent (klass);
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	((FileWatcherClass *) klass)->finalize = file_watcher_finalize;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_type_class_adjust_private_offset (klass, &FileWatcher_private_offset);
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	file_watcher_signals[FILE_WATCHER_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_FILE_WATCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 740 "FileWatcher.c"
}

static void
file_watcher_instance_init (FileWatcher * self,
                            gpointer klass)
{
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	self->priv = file_watcher_get_instance_private (self);
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	self->ref_count = 1;
#line 751 "FileWatcher.c"
}

static void
file_watcher_finalize (FileWatcher * obj)
{
	FileWatcher * self;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_WATCHER, FileWatcher);
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_signal_handlers_destroy (self);
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_g_object_unref0 (self->priv->monitor);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_g_free0 (self->priv->etag);
#line 58 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	_g_object_unref0 (self->priv->_file);
#line 768 "FileWatcher.c"
}

/**
 * This class is used to monitor files, unlike FileMonitor it only emits changed
 * only a single time after a modification of a file, and it will only do so if
 * the etag has changed.
 */
static GType
file_watcher_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_file_watcher_init, value_file_watcher_free_value, value_file_watcher_copy_value, value_file_watcher_peek_pointer, "p", value_file_watcher_collect_value, "p", value_file_watcher_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (FileWatcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_watcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileWatcher), 0, (GInstanceInitFunc) file_watcher_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType file_watcher_type_id;
	file_watcher_type_id = g_type_register_fundamental (g_type_fundamental_next (), "FileWatcher", &g_define_type_info, &g_define_type_fundamental_info, 0);
	FileWatcher_private_offset = g_type_add_instance_private (file_watcher_type_id, sizeof (FileWatcherPrivate));
	return file_watcher_type_id;
}

GType
file_watcher_get_type (void)
{
	static volatile gsize file_watcher_type_id__once = 0;
	if (g_once_init_enter (&file_watcher_type_id__once)) {
		GType file_watcher_type_id;
		file_watcher_type_id = file_watcher_get_type_once ();
		g_once_init_leave (&file_watcher_type_id__once, file_watcher_type_id);
	}
	return file_watcher_type_id__once;
}

gpointer
file_watcher_ref (gpointer instance)
{
	FileWatcher * self;
	self = instance;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	g_atomic_int_inc (&self->ref_count);
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	return instance;
#line 809 "FileWatcher.c"
}

void
file_watcher_unref (gpointer instance)
{
	FileWatcher * self;
	self = instance;
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		FILE_WATCHER_GET_CLASS (self)->finalize (self);
#line 23 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/FileWatcher.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 823 "FileWatcher.c"
	}
}

