/* TaskManager.c generated by valac 0.56.16, the Vala compiler
 * generated from TaskManager.vala, do not modify */

/* Copyright 2014-2017 Go For It! developers
*
* This file is part of Go For It!.
*
* Go For It! is free software: you can redistribute it
* and/or modify it under the terms of version 3 of the
* GNU General Public License as published by the Free Software Foundation.
*
* Go For It! is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with Go For It!. If not, see http://www.gnu.org/licenses/.
*/

#include <glib-object.h>
#include "com.github.jmoerman.go-for-it-0.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_TASK_MANAGER (task_manager_get_type ())
#define TASK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TASK_MANAGER, TaskManager))
#define TASK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TASK_MANAGER, TaskManagerClass))
#define IS_TASK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TASK_MANAGER))
#define IS_TASK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TASK_MANAGER))
#define TASK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TASK_MANAGER, TaskManagerClass))

typedef struct _TaskManager TaskManager;
typedef struct _TaskManagerClass TaskManagerClass;
typedef struct _TaskManagerPrivate TaskManagerPrivate;

#define TYPE_TASK_STORE (task_store_get_type ())
#define TASK_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TASK_STORE, TaskStore))
#define TASK_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TASK_STORE, TaskStoreClass))
#define IS_TASK_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TASK_STORE))
#define IS_TASK_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TASK_STORE))
#define TASK_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TASK_STORE, TaskStoreClass))

typedef struct _TaskStore TaskStore;
typedef struct _TaskStoreClass TaskStoreClass;
#define _settings_manager_unref0(var) ((var == NULL) ? NULL : (var = (settings_manager_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _file_watcher_unref0(var) ((var == NULL) ? NULL : (var = (file_watcher_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _task_manager_unref0(var) ((var == NULL) ? NULL : (var = (task_manager_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecTaskManager ParamSpecTaskManager;
enum  {
	TASK_MANAGER_ACTIVE_TASK_INVALID_SIGNAL,
	TASK_MANAGER_REFRESHING_SIGNAL,
	TASK_MANAGER_REFRESHED_SIGNAL,
	TASK_MANAGER_NUM_SIGNALS
};
static guint task_manager_signals[TASK_MANAGER_NUM_SIGNALS] = {0};

struct _TaskManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TaskManagerPrivate * priv;
	TaskStore* todo_store;
	TaskStore* done_store;
};

struct _TaskManagerClass {
	GTypeClass parent_class;
	void (*finalize) (TaskManager *self);
};

struct _TaskManagerPrivate {
	SettingsManager* settings;
	GFile* todo_txt_dir;
	GFile* todo_txt;
	GFile* done_txt;
	gboolean read_only;
	gboolean need_to_add_tasks;
	gboolean io_failed;
	gboolean refresh_queued;
	FileWatcher* todo_watcher;
	FileWatcher* done_watcher;
	TodoTask* active_task;
	gboolean active_task_found;
	gchar** default_todos;
	gint default_todos_length1;
	gint _default_todos_size_;
	gchar* error_implications;
	gchar* read_error_message;
	gchar* write_error_message;
	gchar* txt_dir_error;
};

struct _Block1Data {
	int _ref_count_;
	TaskManager* self;
	GtkMessageDialog* dialog;
};

struct _ParamSpecTaskManager {
	GParamSpec parent_instance;
};

static gint TaskManager_private_offset;
static gpointer task_manager_parent_class = NULL;

VALA_EXTERN gpointer task_manager_ref (gpointer instance);
VALA_EXTERN void task_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_task_manager (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_task_manager (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_task_manager (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_task_manager (const GValue* value);
VALA_EXTERN GType task_manager_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType task_store_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TaskManager* task_manager_new (SettingsManager* settings);
VALA_EXTERN TaskManager* task_manager_construct (GType object_type,
                                     SettingsManager* settings);
VALA_EXTERN TaskStore* task_store_new (gboolean done_by_default);
VALA_EXTERN TaskStore* task_store_construct (GType object_type,
                                 gboolean done_by_default);
static void task_manager_load_task_stores (TaskManager* self);
static void task_manager_connect_store_signals (TaskManager* self);
static void task_manager_save_todo_tasks (TaskManager* self);
static void _task_manager_load_task_stores_settings_manager_todo_txt_location_changed (SettingsManager* _sender,
                                                                                gpointer self);
VALA_EXTERN void task_manager_set_active_task (TaskManager* self,
                                   TodoTask* task);
VALA_EXTERN void task_manager_add_new_task (TaskManager* self,
                                const gchar* task);
VALA_EXTERN void task_store_add_task (TaskStore* self,
                          TodoTask* task);
VALA_EXTERN void task_manager_mark_task_done (TaskManager* self,
                                  TodoTask* task);
static void task_manager_transfer_task (TaskManager* self,
                                 TodoTask* task,
                                 TaskStore* source,
                                 TaskStore* destination);
VALA_EXTERN void task_store_remove_task (TaskStore* self,
                             TodoTask* task);
static void task_manager_save_done_tasks (TaskManager* self);
VALA_EXTERN void task_manager_clear_done_store (TaskManager* self);
VALA_EXTERN void task_store_clear (TaskStore* self);
VALA_EXTERN void task_manager_refresh (TaskManager* self);
static void task_manager_load_tasks (TaskManager* self);
static gboolean task_manager_auto_refresh (TaskManager* self);
static void _task_manager_save_todo_tasks_task_store_task_data_changed (TaskStore* _sender,
                                                                 gpointer self);
static void _task_manager_save_done_tasks_task_store_task_data_changed (TaskStore* _sender,
                                                                 gpointer self);
static void task_manager_task_done_handler (TaskManager* self,
                                     TaskStore* source,
                                     TodoTask* task);
static void _task_manager_task_done_handler_task_store_task_done_changed (TaskStore* _sender,
                                                                   TodoTask* task,
                                                                   gpointer self);
static void task_manager_remove_invalid (TaskManager* self,
                                  TaskStore* store,
                                  TodoTask* task);
static void _task_manager_remove_invalid_task_store_task_became_invalid (TaskStore* _sender,
                                                                  TodoTask* task,
                                                                  gpointer self);
static void task_manager_show_error_dialog (TaskManager* self,
                                     const gchar* error_message);
static void task_manager_watch_files (TaskManager* self);
static void task_manager_on_file_changed (TaskManager* self);
static void _task_manager_on_file_changed_file_watcher_changed (FileWatcher* _sender,
                                                         gpointer self);
static gboolean _task_manager_auto_refresh_gsource_func (gpointer self);
static void task_manager_write_task_file (TaskManager* self,
                                   TaskStore* store,
                                   GFile* file);
static void task_manager_read_task_file (TaskManager* self,
                                  GFile* file,
                                  gboolean done_by_default);
static void task_manager_add_default_todos (TaskManager* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda4_ (Block1Data* _data1_,
                 gint response_id);
static void ___lambda4__gtk_dialog_response (GtkDialog* _sender,
                                      gint response_id,
                                      gpointer self);
static void task_manager_ensure_file_exists (TaskManager* self,
                                      GFile* file,
                                      GError** error);
static gchar* task_manager_remove_carriage_return (TaskManager* self,
                                            const gchar* line);
static TodoTask* task_manager_string_to_task (TaskManager* self,
                                       const gchar* _line,
                                       gboolean done_by_default);
static gchar* task_manager_task_to_string (TaskManager* self,
                                    TodoTask* task);
static void task_manager_finalize (TaskManager * obj);
static GType task_manager_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
task_manager_get_instance_private (TaskManager* self)
{
	return G_STRUCT_MEMBER_P (self, TaskManager_private_offset);
}

static gpointer
_settings_manager_ref0 (gpointer self)
{
#line 61 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return self ? settings_manager_ref (self) : NULL;
#line 240 "TaskManager.c"
}

static void
_task_manager_load_task_stores_settings_manager_todo_txt_location_changed (SettingsManager* _sender,
                                                                           gpointer self)
{
#line 80 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_load_task_stores ((TaskManager*) self);
#line 249 "TaskManager.c"
}

TaskManager*
task_manager_construct (GType object_type,
                        SettingsManager* settings)
{
	TaskManager* self = NULL;
	SettingsManager* _tmp0_;
	TaskStore* _tmp1_;
	TaskStore* _tmp2_;
#line 60 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 60 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self = (TaskManager*) g_type_create_instance (object_type);
#line 61 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = _settings_manager_ref0 (settings);
#line 61 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_settings_manager_unref0 (self->priv->settings);
#line 61 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->settings = _tmp0_;
#line 63 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->need_to_add_tasks = settings->first_start;
#line 66 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = task_store_new (FALSE);
#line 66 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->todo_store);
#line 66 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->todo_store = _tmp1_;
#line 67 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp2_ = task_store_new (TRUE);
#line 67 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->done_store);
#line 67 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->done_store = _tmp2_;
#line 69 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->refresh_queued = FALSE;
#line 71 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_load_task_stores (self);
#line 72 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_connect_store_signals (self);
#line 75 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (settings->first_start) {
#line 76 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_save_todo_tasks (self);
#line 294 "TaskManager.c"
	}
#line 80 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_connect (settings, "todo-txt-location-changed", (GCallback) _task_manager_load_task_stores_settings_manager_todo_txt_location_changed, self);
#line 60 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return self;
#line 300 "TaskManager.c"
}

TaskManager*
task_manager_new (SettingsManager* settings)
{
#line 60 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return task_manager_construct (TYPE_TASK_MANAGER, settings);
#line 308 "TaskManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 84 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 316 "TaskManager.c"
}

void
task_manager_set_active_task (TaskManager* self,
                              TodoTask* task)
{
	TodoTask* _tmp0_;
#line 83 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 84 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = _g_object_ref0 (task);
#line 84 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->priv->active_task);
#line 84 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->active_task = _tmp0_;
#line 332 "TaskManager.c"
}

/**
     * To be called when adding a new (undone) task.
     */
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1378 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1379 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1379 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1380 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1381 "glib-2.0.vapi"
	result = _result_;
#line 1381 "glib-2.0.vapi"
	return result;
#line 356 "TaskManager.c"
}

void
task_manager_add_new_task (TaskManager* self,
                           const gchar* task)
{
	gchar* _task = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 90 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 90 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (task != NULL);
#line 91 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = string_strip (task);
#line 91 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_task = _tmp0_;
#line 92 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = _task;
#line 92 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (g_strcmp0 (_tmp1_, "") != 0) {
#line 378 "TaskManager.c"
		TaskStore* _tmp2_;
		const gchar* _tmp3_;
		TodoTask* _tmp4_;
		TodoTask* _tmp5_;
#line 93 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp2_ = self->todo_store;
#line 93 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp3_ = _task;
#line 93 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp4_ = todo_task_new (_tmp3_, FALSE);
#line 93 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp5_ = _tmp4_;
#line 93 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_store_add_task (_tmp2_, _tmp5_);
#line 93 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_object_unref0 (_tmp5_);
#line 94 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_save_todo_tasks (self);
#line 397 "TaskManager.c"
	}
#line 90 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_free0 (_task);
#line 401 "TaskManager.c"
}

void
task_manager_mark_task_done (TaskManager* self,
                             TodoTask* task)
{
#line 98 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 98 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (task != NULL);
#line 99 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	todo_task_set_done (task, TRUE);
#line 414 "TaskManager.c"
}

/**
     * Transfers a task from one TaskStore to another.
     */
static void
task_manager_transfer_task (TaskManager* self,
                            TodoTask* task,
                            TaskStore* source,
                            TaskStore* destination)
{
#line 105 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 105 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (task != NULL);
#line 105 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (source != NULL);
#line 105 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (destination != NULL);
#line 108 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_store_remove_task (source, task);
#line 109 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_store_add_task (destination, task);
#line 110 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_save_todo_tasks (self);
#line 111 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_save_done_tasks (self);
#line 442 "TaskManager.c"
}

/**
     * Deletes all task on the "Done" list
     */
void
task_manager_clear_done_store (TaskManager* self)
{
	TaskStore* _tmp0_;
#line 117 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 118 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = self->done_store;
#line 118 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_store_clear (_tmp0_);
#line 120 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_save_done_tasks (self);
#line 460 "TaskManager.c"
}

/**
     * Reloads all tasks.
     */
void
task_manager_refresh (TaskManager* self)
{
	FILE* _tmp0_;
#line 126 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 127 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = stdout;
#line 127 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	fprintf (_tmp0_, "Refreshing\n");
#line 128 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_emit (self, task_manager_signals[TASK_MANAGER_REFRESHING_SIGNAL], 0);
#line 129 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_load_tasks (self);
#line 130 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_emit (self, task_manager_signals[TASK_MANAGER_REFRESHED_SIGNAL], 0);
#line 482 "TaskManager.c"
}

static gboolean
task_manager_auto_refresh (TaskManager* self)
{
	gboolean _tmp0_ = FALSE;
	FileWatcher* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 133 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 134 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = self->priv->todo_watcher;
#line 134 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp2_ = file_watcher_get_being_updated (_tmp1_);
#line 134 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp3_ = _tmp2_;
#line 134 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (_tmp3_) {
#line 134 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp0_ = TRUE;
#line 505 "TaskManager.c"
	} else {
		FileWatcher* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 134 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp4_ = self->priv->done_watcher;
#line 134 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp5_ = file_watcher_get_being_updated (_tmp4_);
#line 134 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp6_ = _tmp5_;
#line 134 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp0_ = _tmp6_;
#line 518 "TaskManager.c"
	}
#line 134 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (_tmp0_) {
#line 135 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		result = TRUE;
#line 135 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		return result;
#line 526 "TaskManager.c"
	}
#line 138 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_refresh (self);
#line 140 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->refresh_queued = FALSE;
#line 142 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	result = FALSE;
#line 142 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return result;
#line 536 "TaskManager.c"
}

static void
_task_manager_save_todo_tasks_task_store_task_data_changed (TaskStore* _sender,
                                                            gpointer self)
{
#line 147 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_save_todo_tasks ((TaskManager*) self);
#line 545 "TaskManager.c"
}

static void
_task_manager_save_done_tasks_task_store_task_data_changed (TaskStore* _sender,
                                                            gpointer self)
{
#line 148 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_save_done_tasks ((TaskManager*) self);
#line 554 "TaskManager.c"
}

static void
_task_manager_task_done_handler_task_store_task_done_changed (TaskStore* _sender,
                                                              TodoTask* task,
                                                              gpointer self)
{
#line 151 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_task_done_handler ((TaskManager*) self, _sender, task);
#line 564 "TaskManager.c"
}

static void
_task_manager_remove_invalid_task_store_task_became_invalid (TaskStore* _sender,
                                                             TodoTask* task,
                                                             gpointer self)
{
#line 155 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_remove_invalid ((TaskManager*) self, _sender, task);
#line 574 "TaskManager.c"
}

static void
task_manager_connect_store_signals (TaskManager* self)
{
	TaskStore* _tmp0_;
	TaskStore* _tmp1_;
	TaskStore* _tmp2_;
	TaskStore* _tmp3_;
	TaskStore* _tmp4_;
	TaskStore* _tmp5_;
#line 145 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 147 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = self->todo_store;
#line 147 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_connect (_tmp0_, "task-data-changed", (GCallback) _task_manager_save_todo_tasks_task_store_task_data_changed, self);
#line 148 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = self->done_store;
#line 148 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_connect (_tmp1_, "task-data-changed", (GCallback) _task_manager_save_done_tasks_task_store_task_data_changed, self);
#line 151 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp2_ = self->todo_store;
#line 151 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_connect (_tmp2_, "task-done-changed", (GCallback) _task_manager_task_done_handler_task_store_task_done_changed, self);
#line 152 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp3_ = self->done_store;
#line 152 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_connect (_tmp3_, "task-done-changed", (GCallback) _task_manager_task_done_handler_task_store_task_done_changed, self);
#line 155 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_ = self->todo_store;
#line 155 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_connect (_tmp4_, "task-became-invalid", (GCallback) _task_manager_remove_invalid_task_store_task_became_invalid, self);
#line 156 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp5_ = self->done_store;
#line 156 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_connect (_tmp5_, "task-became-invalid", (GCallback) _task_manager_remove_invalid_task_store_task_became_invalid, self);
#line 612 "TaskManager.c"
}

static void
task_manager_load_task_stores (TaskManager* self)
{
	FILE* _tmp0_;
	SettingsManager* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	gboolean _tmp10_ = FALSE;
	GFile* _tmp11_;
#line 159 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 160 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = stdout;
#line 160 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	fprintf (_tmp0_, "load_task_stores\n");
#line 161 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = self->priv->settings;
#line 161 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp2_ = settings_manager_get_todo_txt_location (_tmp1_);
#line 161 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp3_ = _tmp2_;
#line 161 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_ = _tmp3_;
#line 161 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp5_ = g_file_new_for_path (_tmp4_);
#line 161 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->priv->todo_txt_dir);
#line 161 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->todo_txt_dir = _tmp5_;
#line 161 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_free0 (_tmp4_);
#line 162 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp6_ = self->priv->todo_txt_dir;
#line 162 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp7_ = g_file_get_child (_tmp6_, "todo.txt");
#line 162 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->priv->todo_txt);
#line 162 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->todo_txt = _tmp7_;
#line 163 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp8_ = self->priv->todo_txt_dir;
#line 163 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp9_ = g_file_get_child (_tmp8_, "done.txt");
#line 163 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->priv->done_txt);
#line 163 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->done_txt = _tmp9_;
#line 166 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp11_ = self->priv->todo_txt_dir;
#line 166 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (g_file_query_exists (_tmp11_, NULL)) {
#line 672 "TaskManager.c"
		GFile* _tmp12_;
#line 167 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp12_ = self->priv->todo_txt_dir;
#line 167 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp10_ = g_file_query_file_type (_tmp12_, G_FILE_QUERY_INFO_NONE, NULL) != G_FILE_TYPE_DIRECTORY;
#line 678 "TaskManager.c"
	} else {
#line 166 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp10_ = FALSE;
#line 682 "TaskManager.c"
	}
#line 165 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (_tmp10_) {
#line 686 "TaskManager.c"
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 169 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		self->priv->io_failed = TRUE;
#line 170 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp13_ = self->priv->txt_dir_error;
#line 170 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_show_error_dialog (self, _tmp13_);
#line 171 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp14_ = self->priv->txt_dir_error;
#line 171 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_warning ("TaskManager.vala:171: %s", _tmp14_);
#line 699 "TaskManager.c"
	} else {
#line 173 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		self->priv->io_failed = FALSE;
#line 703 "TaskManager.c"
	}
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_load_tasks (self);
#line 178 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (!self->priv->io_failed) {
#line 179 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_watch_files (self);
#line 711 "TaskManager.c"
	}
}

static void
_task_manager_on_file_changed_file_watcher_changed (FileWatcher* _sender,
                                                    gpointer self)
{
#line 187 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_on_file_changed ((TaskManager*) self);
#line 721 "TaskManager.c"
}

static void
task_manager_watch_files (TaskManager* self)
{
	GFile* _tmp0_;
	FileWatcher* _tmp1_;
	GFile* _tmp2_;
	FileWatcher* _tmp3_;
	FileWatcher* _tmp4_;
	FileWatcher* _tmp5_;
#line 183 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 184 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = self->priv->todo_txt;
#line 184 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = file_watcher_new (_tmp0_);
#line 184 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_file_watcher_unref0 (self->priv->todo_watcher);
#line 184 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->todo_watcher = _tmp1_;
#line 185 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp2_ = self->priv->done_txt;
#line 185 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp3_ = file_watcher_new (_tmp2_);
#line 185 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_file_watcher_unref0 (self->priv->done_watcher);
#line 185 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->done_watcher = _tmp3_;
#line 187 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_ = self->priv->todo_watcher;
#line 187 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_connect (_tmp4_, "changed", (GCallback) _task_manager_on_file_changed_file_watcher_changed, self);
#line 188 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp5_ = self->priv->done_watcher;
#line 188 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_connect (_tmp5_, "changed", (GCallback) _task_manager_on_file_changed_file_watcher_changed, self);
#line 759 "TaskManager.c"
}

static gboolean
_task_manager_auto_refresh_gsource_func (gpointer self)
{
	gboolean result;
	result = task_manager_auto_refresh ((TaskManager*) self);
#line 197 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return result;
#line 769 "TaskManager.c"
}

static void
task_manager_on_file_changed (TaskManager* self)
{
#line 191 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 192 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (!self->priv->refresh_queued) {
#line 193 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		self->priv->refresh_queued = TRUE;
#line 197 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT_IDLE, (guint) 500, _task_manager_auto_refresh_gsource_func, task_manager_ref (self), task_manager_unref);
#line 783 "TaskManager.c"
	}
}

static void
task_manager_task_done_handler (TaskManager* self,
                                TaskStore* source,
                                TodoTask* task)
{
	TaskStore* _tmp0_;
#line 203 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 203 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (source != NULL);
#line 203 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (task != NULL);
#line 204 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = self->todo_store;
#line 204 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (source == _tmp0_) {
#line 803 "TaskManager.c"
		TaskStore* _tmp1_;
		TaskStore* _tmp2_;
#line 205 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp1_ = self->todo_store;
#line 205 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp2_ = self->done_store;
#line 205 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_transfer_task (self, task, _tmp1_, _tmp2_);
#line 812 "TaskManager.c"
	} else {
		TaskStore* _tmp3_;
#line 206 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp3_ = self->done_store;
#line 206 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		if (source == _tmp3_) {
#line 819 "TaskManager.c"
			TaskStore* _tmp4_;
			TaskStore* _tmp5_;
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp4_ = self->done_store;
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp5_ = self->todo_store;
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			task_manager_transfer_task (self, task, _tmp4_, _tmp5_);
#line 828 "TaskManager.c"
		}
	}
}

static void
task_manager_remove_invalid (TaskManager* self,
                             TaskStore* store,
                             TodoTask* task)
{
	GFile* _tmp0_ = NULL;
	TaskStore* _tmp1_;
	GFile* todo_file = NULL;
	GFile* _tmp4_;
#line 211 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 211 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (store != NULL);
#line 211 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (task != NULL);
#line 212 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_store_remove_task (store, task);
#line 213 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = self->todo_store;
#line 213 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (store == _tmp1_) {
#line 854 "TaskManager.c"
		GFile* _tmp2_;
#line 213 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp2_ = self->priv->todo_txt;
#line 213 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp0_ = _tmp2_;
#line 860 "TaskManager.c"
	} else {
		GFile* _tmp3_;
#line 213 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp3_ = self->priv->done_txt;
#line 213 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp0_ = _tmp3_;
#line 867 "TaskManager.c"
	}
#line 213 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_ = _g_object_ref0 (_tmp0_);
#line 213 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	todo_file = _tmp4_;
#line 214 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_write_task_file (self, store, todo_file);
#line 211 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (todo_file);
#line 877 "TaskManager.c"
}

static void
task_manager_load_tasks (TaskManager* self)
{
	TaskStore* _tmp0_;
	TaskStore* _tmp1_;
	TodoTask* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
#line 217 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 219 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->read_only = TRUE;
#line 220 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = self->todo_store;
#line 220 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_store_clear (_tmp0_);
#line 221 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = self->done_store;
#line 221 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_store_clear (_tmp1_);
#line 222 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp2_ = self->priv->active_task;
#line 222 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->active_task_found = _tmp2_ == NULL;
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp3_ = self->priv->todo_txt;
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_read_task_file (self, _tmp3_, FALSE);
#line 224 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_ = self->priv->done_txt;
#line 224 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_read_task_file (self, _tmp4_, TRUE);
#line 226 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (self->priv->need_to_add_tasks) {
#line 227 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_add_default_todos (self);
#line 916 "TaskManager.c"
	}
#line 230 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->read_only = FALSE;
#line 232 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (!self->priv->active_task_found) {
#line 233 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_signal_emit (self, task_manager_signals[TASK_MANAGER_ACTIVE_TASK_INVALID_SIGNAL], 0);
#line 924 "TaskManager.c"
	}
}

static void
task_manager_add_default_todos (TaskManager* self)
{
#line 237 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 933 "TaskManager.c"
	{
		gint i = 0;
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 239 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp0_ = self->priv->default_todos;
#line 239 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp0__length1 = self->priv->default_todos_length1;
#line 239 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		i = _tmp0__length1 - 1;
#line 944 "TaskManager.c"
		{
			gboolean _tmp1_ = FALSE;
#line 239 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp1_ = TRUE;
#line 239 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			while (TRUE) {
#line 951 "TaskManager.c"
				TaskStore* _tmp3_;
				gchar** _tmp4_;
				gint _tmp4__length1;
				const gchar* _tmp5_;
				TodoTask* _tmp6_;
				TodoTask* _tmp7_;
#line 239 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				if (!_tmp1_) {
#line 960 "TaskManager.c"
					gint _tmp2_;
#line 241 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp2_ = i;
#line 241 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					i = _tmp2_ - 1;
#line 966 "TaskManager.c"
				}
#line 239 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp1_ = FALSE;
#line 240 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				if (!(i >= 0)) {
#line 240 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					break;
#line 974 "TaskManager.c"
				}
#line 243 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp3_ = self->todo_store;
#line 243 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp4_ = self->priv->default_todos;
#line 243 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp4__length1 = self->priv->default_todos_length1;
#line 243 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp5_ = _tmp4_[i];
#line 243 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp6_ = todo_task_new (_tmp5_, FALSE);
#line 243 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp7_ = _tmp6_;
#line 243 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				task_store_add_task (_tmp3_, _tmp7_);
#line 243 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_g_object_unref0 (_tmp7_);
#line 992 "TaskManager.c"
			}
		}
	}
#line 245 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->need_to_add_tasks = FALSE;
#line 998 "TaskManager.c"
}

static void
task_manager_save_todo_tasks (TaskManager* self)
{
#line 248 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 249 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (!self->priv->read_only) {
#line 1008 "TaskManager.c"
		FileWatcher* _tmp0_;
		TaskStore* _tmp1_;
		GFile* _tmp2_;
		FileWatcher* _tmp3_;
#line 250 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp0_ = self->priv->todo_watcher;
#line 250 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		file_watcher_set_watching (_tmp0_, FALSE);
#line 251 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp1_ = self->todo_store;
#line 251 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp2_ = self->priv->todo_txt;
#line 251 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_write_task_file (self, _tmp1_, _tmp2_);
#line 252 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp3_ = self->priv->todo_watcher;
#line 252 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		file_watcher_set_watching (_tmp3_, TRUE);
#line 1027 "TaskManager.c"
	}
}

static void
task_manager_save_done_tasks (TaskManager* self)
{
#line 256 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 257 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (!self->priv->read_only) {
#line 1038 "TaskManager.c"
		FileWatcher* _tmp0_;
		TaskStore* _tmp1_;
		GFile* _tmp2_;
		FileWatcher* _tmp3_;
#line 258 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp0_ = self->priv->done_watcher;
#line 258 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		file_watcher_set_watching (_tmp0_, FALSE);
#line 259 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp1_ = self->done_store;
#line 259 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp2_ = self->priv->done_txt;
#line 259 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_write_task_file (self, _tmp1_, _tmp2_);
#line 260 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp3_ = self->priv->done_watcher;
#line 260 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		file_watcher_set_watching (_tmp3_, TRUE);
#line 1057 "TaskManager.c"
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return _data1_;
#line 1068 "TaskManager.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1078 "TaskManager.c"
		TaskManager* self;
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		self = _data1_->self;
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_object_unref0 (_data1_->dialog);
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_task_manager_unref0 (self);
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_slice_free (Block1Data, _data1_);
#line 1088 "TaskManager.c"
	}
}

static void
__lambda4_ (Block1Data* _data1_,
            gint response_id)
{
	TaskManager* self;
#line 269 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self = _data1_->self;
#line 270 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	gtk_widget_destroy ((GtkWidget*) _data1_->dialog);
#line 1101 "TaskManager.c"
}

static void
___lambda4__gtk_dialog_response (GtkDialog* _sender,
                                 gint response_id,
                                 gpointer self)
{
#line 269 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	__lambda4_ (self, response_id);
#line 1111 "TaskManager.c"
}

static void
task_manager_show_error_dialog (TaskManager* self,
                                const gchar* error_message)
{
	Block1Data* _data1_;
	GtkMessageDialog* _tmp0_;
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (error_message != NULL);
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_data1_->_ref_count_ = 1;
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_data1_->self = task_manager_ref (self);
#line 265 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, "%s", error_message);
#line 265 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_object_ref_sink (_tmp0_);
#line 265 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_data1_->dialog = _tmp0_;
#line 269 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_connect_data ((GtkDialog*) _data1_->dialog, "response", (GCallback) ___lambda4__gtk_dialog_response, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 273 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	gtk_widget_show ((GtkWidget*) _data1_->dialog);
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	block1_data_unref (_data1_);
#line 264 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_data1_ = NULL;
#line 1144 "TaskManager.c"
}

static void
task_manager_ensure_file_exists (TaskManager* self,
                                 GFile* file,
                                 GError** error)
{
	GError* _inner_error0_ = NULL;
#line 276 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 276 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (file != NULL);
#line 278 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (!g_file_query_exists (file, NULL)) {
#line 1159 "TaskManager.c"
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GFileOutputStream* _tmp3_;
		GFileOutputStream* _tmp4_;
#line 279 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp0_ = self->priv->todo_txt_dir;
#line 279 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp1_ = g_file_get_path (_tmp0_);
#line 279 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp2_ = _tmp1_;
#line 279 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_mkdir_with_parents (_tmp2_, 0700);
#line 279 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_free0 (_tmp2_);
#line 280 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp3_ = g_file_create (file, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 280 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp4_ = _tmp3_;
#line 280 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_object_unref0 (_tmp4_);
#line 280 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 280 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			g_propagate_error (error, _inner_error0_);
#line 280 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			return;
#line 1187 "TaskManager.c"
		}
	}
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1278 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1279 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1279 "glib-2.0.vapi"
	return result;
#line 1203 "TaskManager.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1499 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1500 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1500 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1500 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1501 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1502 "glib-2.0.vapi"
		start = string_length + start;
#line 1230 "TaskManager.c"
	}
#line 1504 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1505 "glib-2.0.vapi"
		end = string_length + end;
#line 1236 "TaskManager.c"
	}
#line 1507 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1507 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1242 "TaskManager.c"
	} else {
#line 1507 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1246 "TaskManager.c"
	}
#line 1507 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1508 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1508 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1254 "TaskManager.c"
	} else {
#line 1508 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1258 "TaskManager.c"
	}
#line 1508 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1509 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1510 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1510 "glib-2.0.vapi"
	result = _tmp4_;
#line 1510 "glib-2.0.vapi"
	return result;
#line 1270 "TaskManager.c"
}

static gchar*
task_manager_remove_carriage_return (TaskManager* self,
                                     const gchar* line)
{
	gint length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp4_;
	gchar* result;
#line 284 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 284 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 285 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = strlen (line);
#line 285 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = _tmp0_;
#line 285 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	length = _tmp1_;
#line 286 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (length > 0) {
#line 287 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		if (string_get_char (line, (glong) (length - 1)) == ((gunichar) 13)) {
#line 1296 "TaskManager.c"
			gchar* _tmp3_;
#line 288 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			if (length == 1) {
#line 1300 "TaskManager.c"
				gchar* _tmp2_;
#line 289 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp2_ = g_strdup ("");
#line 289 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				result = _tmp2_;
#line 289 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				return result;
#line 1308 "TaskManager.c"
			}
#line 291 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp3_ = string_slice (line, (glong) 0, (glong) (length - 1));
#line 291 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			result = _tmp3_;
#line 291 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			return result;
#line 1316 "TaskManager.c"
		}
	}
#line 295 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_ = g_strdup (line);
#line 295 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	result = _tmp4_;
#line 295 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return result;
#line 1325 "TaskManager.c"
}

static TodoTask*
task_manager_string_to_task (TaskManager* self,
                             const gchar* _line,
                             gboolean done_by_default)
{
	gchar* line = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean done = FALSE;
	const gchar* _tmp3_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gboolean _tmp13_ = FALSE;
	const gchar* _tmp20_;
	TodoTask* _tmp21_;
	TodoTask* result;
#line 298 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 298 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_val_if_fail (_line != NULL, NULL);
#line 299 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = string_strip (_line);
#line 299 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	line = _tmp0_;
#line 301 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = line;
#line 301 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp2_ = task_manager_remove_carriage_return (self, _tmp1_);
#line 301 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_free0 (line);
#line 301 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	line = _tmp2_;
#line 304 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp3_ = line;
#line 304 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	done = g_str_has_prefix (_tmp3_, "x ");
#line 306 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (done) {
#line 1368 "TaskManager.c"
		const gchar* _tmp4_;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 308 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp4_ = line;
#line 308 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "x ", 2);
#line 308 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp7_ = _tmp6_;
#line 308 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp7__length1 = _vala_array_length (_tmp5_);
#line 308 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp8_ = _tmp7_[1];
#line 308 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 308 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_free0 (line);
#line 308 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		line = _tmp9_;
#line 308 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 1394 "TaskManager.c"
	}
#line 311 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp10_ = line;
#line 311 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp11_ = string_strip (_tmp10_);
#line 311 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_free0 (line);
#line 311 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	line = _tmp11_;
#line 313 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp12_ = line;
#line 313 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (g_strcmp0 (_tmp12_, "") == 0) {
#line 314 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		result = NULL;
#line 314 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_free0 (line);
#line 314 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		return result;
#line 1414 "TaskManager.c"
	}
#line 317 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (!self->priv->active_task_found) {
#line 317 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp13_ = !done;
#line 1420 "TaskManager.c"
	} else {
#line 317 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp13_ = FALSE;
#line 1424 "TaskManager.c"
	}
#line 317 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (_tmp13_) {
#line 1428 "TaskManager.c"
		const gchar* _tmp14_;
		TodoTask* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
#line 318 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp14_ = line;
#line 318 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp15_ = self->priv->active_task;
#line 318 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp16_ = todo_task_get_title (_tmp15_);
#line 318 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp17_ = _tmp16_;
#line 318 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		if (g_strcmp0 (_tmp14_, _tmp17_) == 0) {
#line 1443 "TaskManager.c"
			TodoTask* _tmp18_;
			TodoTask* _tmp19_;
#line 319 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			self->priv->active_task_found = TRUE;
#line 320 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp18_ = self->priv->active_task;
#line 320 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp19_ = _g_object_ref0 (_tmp18_);
#line 320 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			result = _tmp19_;
#line 320 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_g_free0 (line);
#line 320 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			return result;
#line 1458 "TaskManager.c"
		}
	}
#line 324 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp20_ = line;
#line 324 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp21_ = todo_task_new (_tmp20_, done | done_by_default);
#line 324 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	result = _tmp21_;
#line 324 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_free0 (line);
#line 324 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return result;
#line 1471 "TaskManager.c"
}

static gchar*
task_manager_task_to_string (TaskManager* self,
                             TodoTask* task)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 327 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 327 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_val_if_fail (task != NULL, NULL);
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = todo_task_get_done (task);
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp2_ = _tmp1_;
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (_tmp2_) {
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp0_ = "x ";
#line 1497 "TaskManager.c"
	} else {
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp0_ = "";
#line 1501 "TaskManager.c"
	}
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp3_ = todo_task_get_title (task);
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_ = _tmp3_;
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp5_ = g_strconcat (_tmp0_, _tmp4_, NULL);
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	result = _tmp5_;
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return result;
#line 1513 "TaskManager.c"
}

/**
     * Reads tasks from a Todo.txt formatted file.
     */
static void
task_manager_read_task_file (TaskManager* self,
                             GFile* file,
                             gboolean done_by_default)
{
	FILE* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 334 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 334 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (file != NULL);
#line 335 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (self->priv->io_failed) {
#line 336 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		return;
#line 1536 "TaskManager.c"
	}
#line 338 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = stdout;
#line 338 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = g_file_get_path (file);
#line 338 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp2_ = _tmp1_;
#line 338 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	fprintf (_tmp0_, "Reading file: %s\n", _tmp2_);
#line 338 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_free0 (_tmp2_);
#line 1548 "TaskManager.c"
	{
		GFileInputStream* _tmp3_ = NULL;
		GFileInputStream* _tmp4_;
		GDataInputStream* stream_in = NULL;
		GDataInputStream* _tmp5_;
		gchar* line = NULL;
#line 342 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_ensure_file_exists (self, file, &_inner_error0_);
#line 342 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1559 "TaskManager.c"
			goto __catch0_g_error;
		}
#line 343 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp4_ = g_file_read (file, NULL, &_inner_error0_);
#line 343 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp3_ = _tmp4_;
#line 343 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1568 "TaskManager.c"
			goto __catch0_g_error;
		}
#line 343 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp5_ = g_data_input_stream_new ((GInputStream*) _tmp3_);
#line 343 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		stream_in = _tmp5_;
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		while (TRUE) {
#line 1577 "TaskManager.c"
			gchar* _tmp6_ = NULL;
			GDataInputStream* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			const gchar* _tmp10_;
			TodoTask* task = NULL;
			const gchar* _tmp11_;
			TodoTask* _tmp12_;
			TodoTask* _tmp13_;
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp7_ = stream_in;
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp8_ = g_data_input_stream_read_line (_tmp7_, NULL, NULL, &_inner_error0_);
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp6_ = _tmp8_;
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_g_free0 (line);
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_g_object_unref0 (stream_in);
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_g_object_unref0 (_tmp3_);
#line 1601 "TaskManager.c"
				goto __catch0_g_error;
			}
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp9_ = _tmp6_;
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp6_ = NULL;
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_g_free0 (line);
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			line = _tmp9_;
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp10_ = line;
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			if (!(_tmp10_ != NULL)) {
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_g_free0 (_tmp6_);
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				break;
#line 1620 "TaskManager.c"
			}
#line 347 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp11_ = line;
#line 347 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp12_ = task_manager_string_to_task (self, _tmp11_, done_by_default);
#line 347 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			task = _tmp12_;
#line 348 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_tmp13_ = task;
#line 348 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			if (_tmp13_ != NULL) {
#line 1632 "TaskManager.c"
				TodoTask* _tmp14_;
				gboolean _tmp15_;
				gboolean _tmp16_;
#line 349 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp14_ = task;
#line 349 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp15_ = todo_task_get_done (_tmp14_);
#line 349 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp16_ = _tmp15_;
#line 349 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				if (_tmp16_) {
#line 1644 "TaskManager.c"
					TaskStore* _tmp17_;
					TodoTask* _tmp18_;
#line 350 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp17_ = self->done_store;
#line 350 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp18_ = task;
#line 350 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					task_store_add_task (_tmp17_, _tmp18_);
#line 1653 "TaskManager.c"
				} else {
					TaskStore* _tmp19_;
					TodoTask* _tmp20_;
#line 352 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp19_ = self->todo_store;
#line 352 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp20_ = task;
#line 352 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					task_store_add_task (_tmp19_, _tmp20_);
#line 1663 "TaskManager.c"
				}
			}
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_g_object_unref0 (task);
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			_g_free0 (_tmp6_);
#line 1670 "TaskManager.c"
		}
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_free0 (line);
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_object_unref0 (stream_in);
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_object_unref0 (_tmp3_);
#line 1678 "TaskManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* error_message = NULL;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		GError* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		e = _inner_error0_;
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_inner_error0_ = NULL;
#line 357 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		self->priv->io_failed = TRUE;
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp21_ = self->priv->read_error_message;
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp22_ = g_file_get_path (file);
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp23_ = _tmp22_;
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp24_ = e;
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp25_ = _tmp24_->message;
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp26_ = g_strdup_printf (_tmp21_, _tmp23_, _tmp25_);
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp27_ = _tmp26_;
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp28_ = self->priv->error_implications;
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp29_ = g_strconcat (_tmp27_, _tmp28_, NULL);
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp30_ = _tmp29_;
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_free0 (_tmp27_);
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_free0 (_tmp23_);
#line 358 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		error_message = _tmp30_;
#line 359 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp31_ = error_message;
#line 359 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_warning ("TaskManager.vala:359: %s", _tmp31_);
#line 360 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp32_ = error_message;
#line 360 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_show_error_dialog (self, _tmp32_);
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_free0 (error_message);
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_error_free0 (e);
#line 1741 "TaskManager.c"
	}
	__finally0:
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_clear_error (&_inner_error0_);
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		return;
#line 1752 "TaskManager.c"
	}
}

/**
     * Saves tasks to a Todo.txt formatted file.
     */
static void
task_manager_write_task_file (TaskManager* self,
                              TaskStore* store,
                              GFile* file)
{
	FILE* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 367 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (self != NULL);
#line 367 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (store != NULL);
#line 367 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (file != NULL);
#line 368 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (self->priv->io_failed) {
#line 369 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		return;
#line 1778 "TaskManager.c"
	}
#line 371 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = stdout;
#line 371 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = g_file_get_path (file);
#line 371 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp2_ = _tmp1_;
#line 371 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	fprintf (_tmp0_, "Writing file: %s\n", _tmp2_);
#line 371 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_free0 (_tmp2_);
#line 1790 "TaskManager.c"
	{
		GFileIOStream* file_io_stream = NULL;
		GFileIOStream* _tmp3_;
		GDataOutputStream* stream_out = NULL;
		GFileIOStream* _tmp4_;
		GOutputStream* _tmp5_;
		GOutputStream* _tmp6_;
		GDataOutputStream* _tmp7_;
		guint n_items = 0U;
#line 374 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_ensure_file_exists (self, file, &_inner_error0_);
#line 374 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1804 "TaskManager.c"
			goto __catch0_g_error;
		}
#line 375 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp3_ = g_file_replace_readwrite (file, NULL, TRUE, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 375 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		file_io_stream = _tmp3_;
#line 375 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1813 "TaskManager.c"
			goto __catch0_g_error;
		}
#line 377 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp4_ = file_io_stream;
#line 377 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp5_ = g_io_stream_get_output_stream ((GIOStream*) _tmp4_);
#line 377 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp6_ = _tmp5_;
#line 377 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp7_ = g_data_output_stream_new (_tmp6_);
#line 377 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		stream_out = _tmp7_;
#line 380 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		n_items = drag_list_model_get_n_items ((DragListModel*) store);
#line 1828 "TaskManager.c"
		{
			guint i = 0U;
#line 381 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			i = (guint) 0;
#line 1833 "TaskManager.c"
			{
				gboolean _tmp8_ = FALSE;
#line 381 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				_tmp8_ = TRUE;
#line 381 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
				while (TRUE) {
#line 1840 "TaskManager.c"
					TodoTask* task = NULL;
					GObject* _tmp10_;
					GDataOutputStream* _tmp11_;
					TodoTask* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
#line 381 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					if (!_tmp8_) {
#line 1851 "TaskManager.c"
						guint _tmp9_;
#line 381 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
						_tmp9_ = i;
#line 381 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
						i = _tmp9_ + 1;
#line 1857 "TaskManager.c"
					}
#line 381 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp8_ = FALSE;
#line 381 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					if (!(i < n_items)) {
#line 381 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
						break;
#line 1865 "TaskManager.c"
					}
#line 382 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp10_ = drag_list_model_get_item ((DragListModel*) store, i);
#line 382 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					task = G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_TODO_TASK, TodoTask);
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp11_ = stream_out;
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp12_ = task;
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp13_ = task_manager_task_to_string (self, _tmp12_);
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp14_ = _tmp13_;
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp15_ = g_strconcat (_tmp14_, "\n", NULL);
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_tmp16_ = _tmp15_;
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					g_data_output_stream_put_string (_tmp11_, _tmp16_, NULL, &_inner_error0_);
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_g_free0 (_tmp16_);
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_g_free0 (_tmp14_);
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
						_g_object_unref0 (task);
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
						_g_object_unref0 (stream_out);
#line 383 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
						_g_object_unref0 (file_io_stream);
#line 1897 "TaskManager.c"
						goto __catch0_g_error;
					}
#line 381 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
					_g_object_unref0 (task);
#line 1902 "TaskManager.c"
				}
			}
		}
#line 373 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_object_unref0 (stream_out);
#line 373 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_object_unref0 (file_io_stream);
#line 1910 "TaskManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* error_message = NULL;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		GError* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
#line 373 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		e = _inner_error0_;
#line 373 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_inner_error0_ = NULL;
#line 386 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		self->priv->io_failed = TRUE;
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp17_ = self->priv->write_error_message;
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp18_ = g_file_get_path (file);
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp19_ = _tmp18_;
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp20_ = e;
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp21_ = _tmp20_->message;
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp22_ = g_strdup_printf (_tmp17_, _tmp19_, _tmp21_);
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp23_ = _tmp22_;
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp24_ = self->priv->error_implications;
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp25_ = g_strconcat (_tmp23_, _tmp24_, NULL);
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp26_ = _tmp25_;
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_free0 (_tmp23_);
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_free0 (_tmp19_);
#line 387 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		error_message = _tmp26_;
#line 388 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp27_ = error_message;
#line 388 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_warning ("TaskManager.vala:388: %s", _tmp27_);
#line 389 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_tmp28_ = error_message;
#line 389 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_show_error_dialog (self, _tmp28_);
#line 373 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_free0 (error_message);
#line 373 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		_g_error_free0 (e);
#line 1973 "TaskManager.c"
	}
	__finally0:
#line 373 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 373 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 373 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_clear_error (&_inner_error0_);
#line 373 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		return;
#line 1984 "TaskManager.c"
	}
}

static void
value_task_manager_init (GValue* value)
{
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	value->data[0].v_pointer = NULL;
#line 1993 "TaskManager.c"
}

static void
value_task_manager_free_value (GValue* value)
{
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (value->data[0].v_pointer) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_unref (value->data[0].v_pointer);
#line 2003 "TaskManager.c"
	}
}

static void
value_task_manager_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		dest_value->data[0].v_pointer = task_manager_ref (src_value->data[0].v_pointer);
#line 2015 "TaskManager.c"
	} else {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2019 "TaskManager.c"
	}
}

static gpointer
value_task_manager_peek_pointer (const GValue* value)
{
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return value->data[0].v_pointer;
#line 2028 "TaskManager.c"
}

static gchar*
value_task_manager_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (collect_values[0].v_pointer) {
#line 2039 "TaskManager.c"
		TaskManager * object;
		object = collect_values[0].v_pointer;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2046 "TaskManager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2050 "TaskManager.c"
		}
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		value->data[0].v_pointer = task_manager_ref (object);
#line 2054 "TaskManager.c"
	} else {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		value->data[0].v_pointer = NULL;
#line 2058 "TaskManager.c"
	}
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return NULL;
#line 2062 "TaskManager.c"
}

static gchar*
value_task_manager_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	TaskManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (!object_p) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2077 "TaskManager.c"
	}
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (!value->data[0].v_pointer) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		*object_p = NULL;
#line 2083 "TaskManager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		*object_p = value->data[0].v_pointer;
#line 2087 "TaskManager.c"
	} else {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		*object_p = task_manager_ref (value->data[0].v_pointer);
#line 2091 "TaskManager.c"
	}
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return NULL;
#line 2095 "TaskManager.c"
}

GParamSpec*
param_spec_task_manager (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecTaskManager* spec;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_TASK_MANAGER), NULL);
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return G_PARAM_SPEC (spec);
#line 2114 "TaskManager.c"
}

gpointer
value_get_task_manager (const GValue* value)
{
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TASK_MANAGER), NULL);
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return value->data[0].v_pointer;
#line 2124 "TaskManager.c"
}

void
value_set_task_manager (GValue* value,
                        gpointer v_object)
{
	TaskManager * old;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TASK_MANAGER));
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	old = value->data[0].v_pointer;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (v_object) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TASK_MANAGER));
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		value->data[0].v_pointer = v_object;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_ref (value->data[0].v_pointer);
#line 2146 "TaskManager.c"
	} else {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		value->data[0].v_pointer = NULL;
#line 2150 "TaskManager.c"
	}
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (old) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_unref (old);
#line 2156 "TaskManager.c"
	}
}

void
value_take_task_manager (GValue* value,
                         gpointer v_object)
{
	TaskManager * old;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_TASK_MANAGER));
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	old = value->data[0].v_pointer;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (v_object) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_TASK_MANAGER));
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		value->data[0].v_pointer = v_object;
#line 2177 "TaskManager.c"
	} else {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		value->data[0].v_pointer = NULL;
#line 2181 "TaskManager.c"
	}
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (old) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		task_manager_unref (old);
#line 2187 "TaskManager.c"
	}
}

static void
task_manager_class_init (TaskManagerClass * klass,
                         gpointer klass_data)
{
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_parent_class = g_type_class_peek_parent (klass);
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	((TaskManagerClass *) klass)->finalize = task_manager_finalize;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_type_class_adjust_private_offset (klass, &TaskManager_private_offset);
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_signals[TASK_MANAGER_ACTIVE_TASK_INVALID_SIGNAL] = g_signal_new ("active-task-invalid", TYPE_TASK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_signals[TASK_MANAGER_REFRESHING_SIGNAL] = g_signal_new ("refreshing", TYPE_TASK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	task_manager_signals[TASK_MANAGER_REFRESHED_SIGNAL] = g_signal_new ("refreshed", TYPE_TASK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2207 "TaskManager.c"
}

static void
task_manager_instance_init (TaskManager * self,
                            gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv = task_manager_get_instance_private (self);
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp0_ = g_strdup ("Choose Todo.txt folder via \"Settings\"");
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp1_ = g_strdup ("Spread the word about \"Go For It!\"");
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp2_ = g_strdup ("Consider a donation to help the project");
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp3_ = g_strdup ("Consider contributing to the project");
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_ = g_new0 (gchar*, 4 + 1);
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_[0] = _tmp0_;
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_[1] = _tmp1_;
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_[2] = _tmp2_;
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp4_[3] = _tmp3_;
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->default_todos = _tmp4_;
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->default_todos_length1 = 4;
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->_default_todos_size_ = self->priv->default_todos_length1;
#line 51 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp5_ = g_strdup (_ ("Go For It! won't save or load from the current todo.txt directory unti" \
"l it is either restarted or another location is chosen."));
#line 51 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->error_implications = _tmp5_;
#line 52 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp6_ = g_strconcat (_ ("Couldn't read the todo.txt file (%s):"), "\n\n%s\n\n", NULL);
#line 52 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->read_error_message = _tmp6_;
#line 53 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp7_ = g_strconcat (_ ("Couldn't save the todo list (%s):"), "\n\n%s\n\n", NULL);
#line 53 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->write_error_message = _tmp7_;
#line 54 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_tmp8_ = g_strdup (_ ("The path to the todo.txt directory does not point to a directory, but " \
"to a file or mountable location. Please change the path in the setting" \
"s to a suitable directory or remove this file."));
#line 54 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->txt_dir_error = _tmp8_;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->ref_count = 1;
#line 2267 "TaskManager.c"
}

static void
task_manager_finalize (TaskManager * obj)
{
	TaskManager * self;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TASK_MANAGER, TaskManager);
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_signal_handlers_destroy (self);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_settings_manager_unref0 (self->priv->settings);
#line 27 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->priv->todo_txt_dir);
#line 28 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->priv->todo_txt);
#line 29 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->priv->done_txt);
#line 30 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->todo_store);
#line 31 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->done_store);
#line 38 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_file_watcher_unref0 (self->priv->todo_watcher);
#line 39 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_file_watcher_unref0 (self->priv->done_watcher);
#line 41 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_object_unref0 (self->priv->active_task);
#line 44 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	self->priv->default_todos = (_vala_array_free (self->priv->default_todos, self->priv->default_todos_length1, (GDestroyNotify) g_free), NULL);
#line 51 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_free0 (self->priv->error_implications);
#line 52 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_free0 (self->priv->read_error_message);
#line 53 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_free0 (self->priv->write_error_message);
#line 54 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	_g_free0 (self->priv->txt_dir_error);
#line 2306 "TaskManager.c"
}

/**
 * This class is responsible for loading, saving and managing the user's tasks.
 * Therefore it offers methods for interacting with the set of tasks in all
 * lists. Editing specific tasks (e.g. removing, renaming) is to be done
 * by addressing the corresponding TaskStore instance.
 */
static GType
task_manager_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_task_manager_init, value_task_manager_free_value, value_task_manager_copy_value, value_task_manager_peek_pointer, "p", value_task_manager_collect_value, "p", value_task_manager_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TaskManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) task_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TaskManager), 0, (GInstanceInitFunc) task_manager_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType task_manager_type_id;
	task_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TaskManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TaskManager_private_offset = g_type_add_instance_private (task_manager_type_id, sizeof (TaskManagerPrivate));
	return task_manager_type_id;
}

GType
task_manager_get_type (void)
{
	static volatile gsize task_manager_type_id__once = 0;
	if (g_once_init_enter (&task_manager_type_id__once)) {
		GType task_manager_type_id;
		task_manager_type_id = task_manager_get_type_once ();
		g_once_init_leave (&task_manager_type_id__once, task_manager_type_id);
	}
	return task_manager_type_id__once;
}

gpointer
task_manager_ref (gpointer instance)
{
	TaskManager * self;
	self = instance;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	return instance;
#line 2348 "TaskManager.c"
}

void
task_manager_unref (gpointer instance)
{
	TaskManager * self;
	self = instance;
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		TASK_MANAGER_GET_CLASS (self)->finalize (self);
#line 24 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/TaskManager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2362 "TaskManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

