/* DragList.c generated by valac 0.56.16, the Vala compiler
 * generated from DragList.vala, do not modify */

/* Copyright 2017 Go For It! developers
*
* This file is part of Go For It!.
*
* Go For It! is free software: you can redistribute it
* and/or modify it under the terms of version 3 of the
* GNU General Public License as published by the Free Software Foundation.
*
* Go For It! is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with Go For It!. If not, see http://www.gnu.org/licenses/.
*/

#include "com.github.jmoerman.go-for-it-0.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define DRAG_LIST_SCROLL_STEP_SIZE 8
#define DRAG_LIST_SCROLL_DISTANCE 30
#define DRAG_LIST_SCROLL_DELAY 50
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_INT_RANGE (int_range_get_type ())
typedef struct _IntRange IntRange;
enum  {
	DRAG_LIST_0_PROPERTY,
	DRAG_LIST_VADJUSTMENT_PROPERTY,
	DRAG_LIST_NUM_PROPERTIES
};
static GParamSpec* drag_list_properties[DRAG_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	DRAG_LIST_ACTIVATE_CURSOR_ROW_SIGNAL,
	DRAG_LIST_ROW_ACTIVATED_SIGNAL,
	DRAG_LIST_MOVE_CURSOR_SIGNAL,
	DRAG_LIST_ROW_SELECTED_SIGNAL,
	DRAG_LIST_ROW_RECEIVED_WITH_MODEL_SIGNAL,
	DRAG_LIST_NUM_SIGNALS
};
static guint drag_list_signals[DRAG_LIST_NUM_SIGNALS] = {0};
enum  {
	DRAG_LIST_ROW_0_PROPERTY,
	DRAG_LIST_ROW_NUM_PROPERTIES
};
static GParamSpec* drag_list_row_properties[DRAG_LIST_ROW_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _IntRange {
	gint min;
	gint max;
};

struct _DragListPrivate {
	GtkListBox* listbox;
	DragListCreateWidgetFunc create_widget_func;
	gpointer create_widget_func_target;
	GDestroyNotify create_widget_func_target_destroy_notify;
	DragListRow* hover_row_top;
	DragListRow* hover_row_bottom;
	gboolean should_scroll;
	gboolean scrolling;
	gboolean scroll_up;
	gboolean ranges_set;
	IntRange input_range;
	IntRange drag_row_range;
	IntRange current_hover_range;
	gboolean internal_signal;
	gboolean block_row_selected;
};

struct _Block2Data {
	int _ref_count_;
	DragList* self;
	DragListFilterFunc filter_func;
	gpointer filter_func_target;
};

struct _DragListRowPrivate {
	GtkEventBox* handle;
	GtkBox* layout;
	GtkImage* image;
	GtkWidget* start_widget;
	GtkWidget* center_widget;
};

static gint DragList_private_offset;
static gpointer drag_list_parent_class = NULL;
static gint DragListRow_private_offset;
static gpointer drag_list_row_parent_class = NULL;

VALA_EXTERN GType int_range_get_type (void) G_GNUC_CONST ;
VALA_EXTERN IntRange* int_range_dup (const IntRange* self);
VALA_EXTERN void int_range_free (IntRange* self);
static void drag_list_on_list_row_activated (DragList* self,
                                      GtkListBoxRow* row);
static void drag_list_on_list_move_cursor (DragList* self,
                                    GtkMovementStep step,
                                    gint count);
static void drag_list_on_list_row_selected (DragList* self,
                                     GtkListBoxRow* row);
static void drag_list_connect_signals (DragList* self);
static void _drag_list_on_list_move_cursor_gtk_list_box_move_cursor (GtkListBox* _sender,
                                                              GtkMovementStep step,
                                                              gint count,
                                                              gpointer self);
static void _drag_list_on_list_row_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                  GtkListBoxRow* row,
                                                                  gpointer self);
static void _drag_list_on_list_row_selected_gtk_list_box_row_selected (GtkListBox* _sender,
                                                                GtkListBoxRow* row,
                                                                gpointer self);
static gboolean drag_list_on_list_drag_motion (DragList* self,
                                        GdkDragContext* context,
                                        gint x,
                                        gint y,
                                        guint time_);
static gboolean _drag_list_on_list_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender,
                                                                GdkDragContext* context,
                                                                gint x,
                                                                gint y,
                                                                guint time_,
                                                                gpointer self);
static void drag_list_on_list_drag_leave (DragList* self,
                                   GdkDragContext* context,
                                   guint time_);
static void _drag_list_on_list_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender,
                                                          GdkDragContext* context,
                                                          guint time_,
                                                          gpointer self);
static void drag_list_on_list_drag_data_received (DragList* self,
                                           GdkDragContext* context,
                                           gint x,
                                           gint y,
                                           GtkSelectionData* selection_data,
                                           guint info,
                                           guint time_);
static void _drag_list_on_list_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                          GdkDragContext* context,
                                                                          gint x,
                                                                          gint y,
                                                                          GtkSelectionData* selection_data,
                                                                          guint info,
                                                                          guint time_,
                                                                          gpointer self);
static void drag_list_disconnect_model_signals (DragList* self);
static void __lambda7_ (DragList* self,
                 GtkWidget* widget);
static void ___lambda7__gtk_callback (GtkWidget* widget,
                               gpointer self);
static inline void _drag_list_add_row (DragList* self,
                         GtkWidget* widget);
static void drag_list_on_model_items_changed (DragList* self,
                                       guint index,
                                       guint removed,
                                       guint added);
static void _drag_list_on_model_items_changed_drag_list_model_items_changed (DragListModel* _sender,
                                                                      guint position,
                                                                      guint removed,
                                                                      guint added,
                                                                      gpointer self);
static void drag_list_on_model_item_moved (DragList* self,
                                    guint old_index,
                                    guint new_index);
static void _drag_list_on_model_item_moved_drag_list_model_item_moved (DragListModel* _sender,
                                                                guint old_position,
                                                                guint new_position,
                                                                gpointer self);
static void _drag_list_insert_row (DragList* self,
                            GtkWidget* widget,
                            gint position);
static void drag_list_select_closest_to (DragList* self,
                                  gint index);
static void _drag_list_move_row (DragList* self,
                          DragListRow* row,
                          gint index,
                          gboolean relative);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda8_ (Block2Data* _data2_,
                     GtkListBoxRow* row);
static gboolean ___lambda8__gtk_list_box_filter_func (GtkListBoxRow* row,
                                               gpointer self);
static void drag_list_set_ranges (DragList* self);
static void drag_list_set_drag_row_range (DragList* self);
static gint drag_list_get_widget_middle (DragList* self,
                                  GtkWidget* widget);
VALA_EXTERN gint int_range_clamp (IntRange *self,
                      gint val);
VALA_EXTERN gboolean int_range_contains (IntRange *self,
                             gint val);
static void drag_list_remove_hover_style (DragList* self);
static void drag_list_set_hover_rows (DragList* self,
                               gint y);
static void drag_list_add_hover_style (DragList* self);
static void drag_list_check_scroll (DragList* self,
                             gint y);
static gboolean drag_list_scroll (DragList* self);
static gboolean _drag_list_scroll_gsource_func (gpointer self);
static void drag_list_set_hover_rows_deadzone (DragList* self);
static void drag_list_set_hover_rows_from_y (DragList* self,
                                      gint y);
static void drag_list_drag_insert_row (DragList* self,
                                DragListRow* row,
                                gint index);
static void drag_list_real_activate_cursor_row (DragList* self);
static void drag_list_real_row_activated (DragList* self,
                                   DragListRow* row);
static void drag_list_real_move_cursor (DragList* self,
                                 GtkMovementStep step,
                                 gint count);
static void g_cclosure_user_marshal_VOID__ENUM_INT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data);
static void drag_list_real_row_selected (DragList* self,
                                  DragListRow* row);
static void drag_list_real_row_received_with_model (DragList* self,
                                             DragListRow* row,
                                             gint index);
static void g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static void drag_list_finalize (GObject * obj);
static GType drag_list_get_type_once (void);
static void _vala_drag_list_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_drag_list_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static void drag_list_row_handle_drag_begin (DragListRow* self,
                                      GdkDragContext* context);
static void _drag_list_row_handle_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                             GdkDragContext* context,
                                                             gpointer self);
static void drag_list_row_handle_drag_data_get (DragListRow* self,
                                         GdkDragContext* context,
                                         GtkSelectionData* selection_data,
                                         guint info,
                                         guint time_);
static void _drag_list_row_handle_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                   GdkDragContext* context,
                                                                   GtkSelectionData* selection_data,
                                                                   guint info,
                                                                   guint time_,
                                                                   gpointer self);
static void drag_list_row_finalize (GObject * obj);
static GType drag_list_row_get_type_once (void);

const GtkTargetEntry dlb_entries[1] = {{"DRAG_LIST_ROW", (guint) GTK_TARGET_SAME_APP, (guint) 0}};

static inline gpointer
drag_list_get_instance_private (DragList* self)
{
	return G_STRUCT_MEMBER_P (self, DragList_private_offset);
}

static void
drag_list_on_list_row_activated (DragList* self,
                                 GtkListBoxRow* row)
{
#line 79 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 79 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 80 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_emit (self, drag_list_signals[DRAG_LIST_ROW_ACTIVATED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (row, TYPE_DRAG_LIST_ROW, DragListRow));
#line 304 "DragList.c"
}

static void
drag_list_on_list_move_cursor (DragList* self,
                               GtkMovementStep step,
                               gint count)
{
#line 91 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 92 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (!self->priv->internal_signal) {
#line 93 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		g_signal_emit (self, drag_list_signals[DRAG_LIST_MOVE_CURSOR_SIGNAL], 0, step, count);
#line 318 "DragList.c"
	}
}

static void
drag_list_on_list_row_selected (DragList* self,
                                GtkListBoxRow* row)
{
#line 105 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 106 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (!self->priv->block_row_selected) {
#line 107 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		g_signal_emit (self, drag_list_signals[DRAG_LIST_ROW_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (row, TYPE_DRAG_LIST_ROW, DragListRow));
#line 332 "DragList.c"
	}
}

DragList*
drag_list_construct (GType object_type)
{
	DragList * self = NULL;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
#line 122 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self = (DragList*) g_object_new (object_type, NULL);
#line 123 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = (GtkListBox*) gtk_list_box_new ();
#line 123 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_object_ref_sink (_tmp0_);
#line 123 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->listbox);
#line 123 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->listbox = _tmp0_;
#line 124 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = self->priv->listbox;
#line 124 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_list_box_set_selection_mode (_tmp1_, GTK_SELECTION_BROWSE);
#line 125 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = self->priv->listbox;
#line 125 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_list_box_set_activate_on_single_click (_tmp2_, FALSE);
#line 126 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = self->priv->listbox;
#line 126 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_drag_dest_set ((GtkWidget*) _tmp3_, GTK_DEST_DEFAULT_ALL, dlb_entries, (gint) G_N_ELEMENTS (dlb_entries), GDK_ACTION_MOVE);
#line 130 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->internal_signal = FALSE;
#line 131 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->block_row_selected = FALSE;
#line 133 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp4_ = self->priv->listbox;
#line 133 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp4_);
#line 134 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_connect_signals (self);
#line 122 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return self;
#line 379 "DragList.c"
}

DragList*
drag_list_new (void)
{
#line 122 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return drag_list_construct (TYPE_DRAG_LIST);
#line 387 "DragList.c"
}

static void
_drag_list_on_list_move_cursor_gtk_list_box_move_cursor (GtkListBox* _sender,
                                                         GtkMovementStep step,
                                                         gint count,
                                                         gpointer self)
{
#line 138 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_on_list_move_cursor ((DragList*) self, step, count);
#line 398 "DragList.c"
}

static void
_drag_list_on_list_row_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                             GtkListBoxRow* row,
                                                             gpointer self)
{
#line 139 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_on_list_row_activated ((DragList*) self, row);
#line 408 "DragList.c"
}

static void
_drag_list_on_list_row_selected_gtk_list_box_row_selected (GtkListBox* _sender,
                                                           GtkListBoxRow* row,
                                                           gpointer self)
{
#line 140 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_on_list_row_selected ((DragList*) self, row);
#line 418 "DragList.c"
}

static gboolean
_drag_list_on_list_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender,
                                                       GdkDragContext* context,
                                                       gint x,
                                                       gint y,
                                                       guint time_,
                                                       gpointer self)
{
	gboolean result;
	result = drag_list_on_list_drag_motion ((DragList*) self, context, x, y, time_);
#line 141 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 433 "DragList.c"
}

static void
_drag_list_on_list_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender,
                                                     GdkDragContext* context,
                                                     guint time_,
                                                     gpointer self)
{
#line 142 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_on_list_drag_leave ((DragList*) self, context, time_);
#line 444 "DragList.c"
}

static void
_drag_list_on_list_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                     GdkDragContext* context,
                                                                     gint x,
                                                                     gint y,
                                                                     GtkSelectionData* selection_data,
                                                                     guint info,
                                                                     guint time_,
                                                                     gpointer self)
{
#line 143 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_on_list_drag_data_received ((DragList*) self, context, x, y, selection_data, info, time_);
#line 459 "DragList.c"
}

static void
drag_list_connect_signals (DragList* self)
{
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
#line 137 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 138 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 138 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_connect_object (_tmp0_, "move-cursor", (GCallback) _drag_list_on_list_move_cursor_gtk_list_box_move_cursor, self, 0);
#line 139 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = self->priv->listbox;
#line 139 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_connect_object (_tmp1_, "row-activated", (GCallback) _drag_list_on_list_row_activated_gtk_list_box_row_activated, self, G_CONNECT_AFTER);
#line 140 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = self->priv->listbox;
#line 140 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_connect_object (_tmp2_, "row-selected", (GCallback) _drag_list_on_list_row_selected_gtk_list_box_row_selected, self, 0);
#line 141 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = self->priv->listbox;
#line 141 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_connect_object ((GtkWidget*) _tmp3_, "drag-motion", (GCallback) _drag_list_on_list_drag_motion_gtk_widget_drag_motion, self, 0);
#line 142 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp4_ = self->priv->listbox;
#line 142 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_connect_object ((GtkWidget*) _tmp4_, "drag-leave", (GCallback) _drag_list_on_list_drag_leave_gtk_widget_drag_leave, self, 0);
#line 143 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp5_ = self->priv->listbox;
#line 143 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_connect_object ((GtkWidget*) _tmp5_, "drag-data-received", (GCallback) _drag_list_on_list_drag_data_received_gtk_widget_drag_data_received, self, 0);
#line 497 "DragList.c"
}

/**
     * Binds model to this.
     *
     * If this was already bound to a model, that previous binding is destroyed.
     *
     * The contents of this are cleared and then filled with widgets that
     * represent items from model. this is updated whenever model changes.
     *
     * If model is null, this is left empty.
     *
     * It is undefined to add, remove or move widgets directly
     * (for example, with insert_row or add_row) while this is bound to a model.
     *
     * @paran model the DragListModel to be bound to this
     * @param create_widget_func a function that creates Widgets for items or null in
     * case you also passed null as model
     */
static void
__lambda7_ (DragList* self,
            GtkWidget* widget)
{
#line 171 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (widget != NULL);
#line 172 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_container_remove ((GtkContainer*) self, widget);
#line 525 "DragList.c"
}

static void
___lambda7__gtk_callback (GtkWidget* widget,
                          gpointer self)
{
#line 171 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	__lambda7_ ((DragList*) self, widget);
#line 534 "DragList.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 175 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return self ? g_object_ref (self) : NULL;
#line 542 "DragList.c"
}

static void
_drag_list_on_model_items_changed_drag_list_model_items_changed (DragListModel* _sender,
                                                                 guint position,
                                                                 guint removed,
                                                                 guint added,
                                                                 gpointer self)
{
#line 187 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_on_model_items_changed ((DragList*) self, position, removed, added);
#line 554 "DragList.c"
}

static void
_drag_list_on_model_item_moved_drag_list_model_item_moved (DragListModel* _sender,
                                                           guint old_position,
                                                           guint new_position,
                                                           gpointer self)
{
#line 188 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_on_model_item_moved ((DragList*) self, old_position, new_position);
#line 565 "DragList.c"
}

void
drag_list_bind_model (DragList* self,
                      DragListModel* model,
                      DragListCreateWidgetFunc create_widget_func,
                      gpointer create_widget_func_target,
                      GDestroyNotify create_widget_func_target_destroy_notify)
{
	GtkListBox* _tmp0_;
	DragListModel* _tmp1_;
	DragListCreateWidgetFunc _tmp2_;
	gpointer _tmp2__target;
	GDestroyNotify _tmp2__target_destroy_notify;
	DragListModel* _tmp3_;
#line 163 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 166 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (model == NULL) {
#line 167 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_vala_assert (create_widget_func == NULL, "create_widget_func == null");
#line 587 "DragList.c"
	}
#line 170 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_disconnect_model_signals (self);
#line 171 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 171 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_container_foreach ((GtkContainer*) _tmp0_, ___lambda7__gtk_callback, self);
#line 175 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = _g_object_ref0 (model);
#line 175 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->model);
#line 175 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->model = _tmp1_;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = create_widget_func;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2__target = create_widget_func_target;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2__target_destroy_notify = create_widget_func_target_destroy_notify;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	create_widget_func = NULL;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	create_widget_func_target = NULL;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	create_widget_func_target_destroy_notify = NULL;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	(self->priv->create_widget_func_target_destroy_notify == NULL) ? NULL : (self->priv->create_widget_func_target_destroy_notify (self->priv->create_widget_func_target), NULL);
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->create_widget_func = NULL;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->create_widget_func_target = NULL;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->create_widget_func_target_destroy_notify = NULL;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->create_widget_func = _tmp2_;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->create_widget_func_target = _tmp2__target;
#line 176 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->create_widget_func_target_destroy_notify = _tmp2__target_destroy_notify;
#line 178 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = self->model;
#line 178 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp3_ == NULL) {
#line 179 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		(create_widget_func_target_destroy_notify == NULL) ? NULL : (create_widget_func_target_destroy_notify (create_widget_func_target), NULL);
#line 179 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		create_widget_func = NULL;
#line 179 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		create_widget_func_target = NULL;
#line 179 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		create_widget_func_target_destroy_notify = NULL;
#line 179 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		return;
#line 641 "DragList.c"
	}
	{
		guint i = 0U;
#line 182 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		i = (guint) 0;
#line 647 "DragList.c"
		{
			gboolean _tmp4_ = FALSE;
#line 182 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp4_ = TRUE;
#line 182 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			while (TRUE) {
#line 654 "DragList.c"
				GtkWidget* row = NULL;
				DragListCreateWidgetFunc _tmp6_;
				gpointer _tmp6__target;
				GObject* _tmp7_;
				GObject* _tmp8_;
				GtkWidget* _tmp9_;
				GtkWidget* _tmp10_;
				GtkWidget* _tmp11_;
#line 182 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				if (!_tmp4_) {
#line 665 "DragList.c"
					guint _tmp5_;
#line 182 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					_tmp5_ = i;
#line 182 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					i = _tmp5_ + 1;
#line 671 "DragList.c"
				}
#line 182 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp4_ = FALSE;
#line 182 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				if (!(i < drag_list_model_get_n_items (model))) {
#line 182 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					break;
#line 679 "DragList.c"
				}
#line 183 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp6_ = self->priv->create_widget_func;
#line 183 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp6__target = self->priv->create_widget_func_target;
#line 183 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp7_ = drag_list_model_get_item (model, i);
#line 183 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp8_ = _tmp7_;
#line 183 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp9_ = _tmp6_ (_tmp8_, _tmp6__target);
#line 183 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp10_ = _tmp9_;
#line 183 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_g_object_unref0 (_tmp8_);
#line 183 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				row = _tmp10_;
#line 184 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp11_ = row;
#line 184 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_drag_list_add_row (self, _tmp11_);
#line 182 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_g_object_unref0 (row);
#line 703 "DragList.c"
			}
		}
	}
#line 187 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_connect_object (model, "items-changed", (GCallback) _drag_list_on_model_items_changed_drag_list_model_items_changed, self, 0);
#line 188 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_connect_object (model, "item-moved", (GCallback) _drag_list_on_model_item_moved_drag_list_model_item_moved, self, 0);
#line 163 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	(create_widget_func_target_destroy_notify == NULL) ? NULL : (create_widget_func_target_destroy_notify (create_widget_func_target), NULL);
#line 163 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	create_widget_func = NULL;
#line 163 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	create_widget_func_target = NULL;
#line 163 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	create_widget_func_target_destroy_notify = NULL;
#line 719 "DragList.c"
}

static void
drag_list_disconnect_model_signals (DragList* self)
{
	DragListModel* _tmp0_;
#line 191 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 192 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->model;
#line 192 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 732 "DragList.c"
		DragListModel* _tmp1_;
		guint _tmp2_;
		DragListModel* _tmp3_;
		guint _tmp4_;
#line 193 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp1_ = self->model;
#line 193 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		g_signal_parse_name ("items-changed", TYPE_DRAG_LIST_MODEL, &_tmp2_, NULL, FALSE);
#line 193 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _drag_list_on_model_items_changed_drag_list_model_items_changed, self);
#line 194 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp3_ = self->model;
#line 194 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		g_signal_parse_name ("item-moved", TYPE_DRAG_LIST_MODEL, &_tmp4_, NULL, FALSE);
#line 194 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _drag_list_on_model_item_moved_drag_list_model_item_moved, self);
#line 749 "DragList.c"
	}
}

static void
drag_list_on_model_items_changed (DragList* self,
                                  guint index,
                                  guint removed,
                                  guint added)
{
	gboolean need_to_select_closest = FALSE;
	gboolean _tmp0_ = FALSE;
#line 198 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 199 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	need_to_select_closest = FALSE;
#line 200 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->block_row_selected = TRUE;
#line 201 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (removed > ((guint) 0)) {
#line 201 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp0_ = added == ((guint) 0);
#line 771 "DragList.c"
	} else {
#line 201 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp0_ = FALSE;
#line 775 "DragList.c"
	}
#line 201 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp0_) {
#line 779 "DragList.c"
		DragListRow* selected_row = NULL;
		DragListRow* _tmp1_;
		DragListRow* _tmp2_;
		guint selected_index = 0U;
		DragListRow* _tmp3_;
		gboolean _tmp4_ = FALSE;
#line 202 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp1_ = drag_list_get_selected_row (self);
#line 202 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		selected_row = _tmp1_;
#line 203 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp2_ = selected_row;
#line 203 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_vala_assert (_tmp2_ != NULL, "selected_row != null");
#line 204 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp3_ = selected_row;
#line 204 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		selected_index = (guint) gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp3_);
#line 205 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (index <= selected_index) {
#line 205 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp4_ = (index + removed) > selected_index;
#line 802 "DragList.c"
		} else {
#line 205 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp4_ = FALSE;
#line 806 "DragList.c"
		}
#line 205 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		need_to_select_closest = _tmp4_;
#line 201 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (selected_row);
#line 812 "DragList.c"
	}
	{
		guint i = 0U;
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		i = (guint) 0;
#line 818 "DragList.c"
		{
			gboolean _tmp5_ = FALSE;
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp5_ = TRUE;
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			while (TRUE) {
#line 825 "DragList.c"
				DragListRow* row = NULL;
				DragListRow* _tmp7_;
				GtkListBox* _tmp8_;
				DragListRow* _tmp9_;
				DragListRow* _tmp10_;
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				if (!_tmp5_) {
#line 833 "DragList.c"
					guint _tmp6_;
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					_tmp6_ = i;
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					i = _tmp6_ + 1;
#line 839 "DragList.c"
				}
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp5_ = FALSE;
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				if (!(i < removed)) {
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					break;
#line 847 "DragList.c"
				}
#line 208 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp7_ = drag_list_get_row_at_index (self, (gint) index);
#line 208 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				row = _tmp7_;
#line 209 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp8_ = self->priv->listbox;
#line 209 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp9_ = row;
#line 209 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				gtk_container_remove ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
#line 214 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp10_ = row;
#line 214 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				if (gtk_list_box_row_is_selected ((GtkListBoxRow*) _tmp10_)) {
#line 863 "DragList.c"
					DragListRow* _tmp11_;
					DragListRow* _tmp12_;
#line 215 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					_tmp11_ = row;
#line 215 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					gtk_list_box_row_set_selectable ((GtkListBoxRow*) _tmp11_, FALSE);
#line 216 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					_tmp12_ = row;
#line 216 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					gtk_list_box_row_set_selectable ((GtkListBoxRow*) _tmp12_, TRUE);
#line 874 "DragList.c"
				}
#line 207 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_g_object_unref0 (row);
#line 878 "DragList.c"
			}
		}
	}
#line 219 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (added > ((guint) 0)) {
#line 220 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->block_row_selected = FALSE;
#line 886 "DragList.c"
	}
	{
		guint i = 0U;
#line 222 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		i = index;
#line 892 "DragList.c"
		{
			gboolean _tmp13_ = FALSE;
#line 222 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp13_ = TRUE;
#line 222 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			while (TRUE) {
#line 899 "DragList.c"
				DragListCreateWidgetFunc _tmp15_;
				gpointer _tmp15__target;
				DragListModel* _tmp16_;
				GObject* _tmp17_;
				GObject* _tmp18_;
				GtkWidget* _tmp19_;
				GtkWidget* _tmp20_;
#line 222 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				if (!_tmp13_) {
#line 909 "DragList.c"
					guint _tmp14_;
#line 222 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					_tmp14_ = i;
#line 222 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					i = _tmp14_ + 1;
#line 915 "DragList.c"
				}
#line 222 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp13_ = FALSE;
#line 222 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				if (!(i < (index + added))) {
#line 222 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
					break;
#line 923 "DragList.c"
				}
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp15_ = self->priv->create_widget_func;
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp15__target = self->priv->create_widget_func_target;
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp16_ = self->model;
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp17_ = drag_list_model_get_item (_tmp16_, i);
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp18_ = _tmp17_;
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp19_ = _tmp15_ (_tmp18_, _tmp15__target);
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp20_ = _tmp19_;
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_drag_list_insert_row (self, _tmp20_, (gint) i);
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_g_object_unref0 (_tmp20_);
#line 223 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_g_object_unref0 (_tmp18_);
#line 945 "DragList.c"
			}
		}
	}
#line 225 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (need_to_select_closest) {
#line 226 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		drag_list_select_closest_to (self, (gint) index);
#line 227 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->block_row_selected = FALSE;
#line 955 "DragList.c"
	}
}

static void
drag_list_on_model_item_moved (DragList* self,
                               guint old_index,
                               guint new_index)
{
	DragListRow* _tmp0_;
	DragListRow* _tmp1_;
#line 231 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 232 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = drag_list_get_row_at_index (self, (gint) old_index);
#line 232 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DRAG_LIST_ROW, DragListRow);
#line 232 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_drag_list_move_row (self, _tmp1_, (gint) new_index, FALSE);
#line 232 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (_tmp1_);
#line 976 "DragList.c"
}

/**
     * Returns the currently selected row.
     */
DragListRow*
drag_list_get_selected_row (DragList* self)
{
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	DragListRow* _tmp2_;
	DragListRow* result;
#line 240 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 241 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 241 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = gtk_list_box_get_selected_row (_tmp0_);
#line 241 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DRAG_LIST_ROW, DragListRow));
#line 241 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = _tmp2_;
#line 241 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 1001 "DragList.c"
}

/**
     * Make row the currently selected row.
     *
     * @param row DragListRow to select
     */
void
drag_list_select_row (DragList* self,
                      DragListRow* row)
{
	GtkListBox* _tmp0_;
#line 249 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 249 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 250 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 250 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_list_box_select_row (_tmp0_, (GtkListBoxRow*) row);
#line 1022 "DragList.c"
}

/**
     * Used to select a row after the selected row was removed
     */
static void
drag_list_select_closest_to (DragList* self,
                             gint index)
{
	DragListRow* next = NULL;
	DragListRow* _tmp0_;
	DragListRow* _tmp1_;
	GtkListBox* _tmp3_;
	DragListRow* _tmp4_;
	DragListRow* _tmp5_;
#line 256 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 257 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = drag_list_get_row_at_index (self, index);
#line 257 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	next = _tmp0_;
#line 258 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = next;
#line 258 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp1_ == NULL) {
#line 1048 "DragList.c"
		DragListRow* _tmp2_;
#line 259 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp2_ = drag_list_get_row_at_index (self, index - 1);
#line 259 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (next);
#line 259 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		next = _tmp2_;
#line 1056 "DragList.c"
	}
#line 261 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = self->priv->listbox;
#line 261 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp4_ = next;
#line 261 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_list_box_select_row (_tmp3_, (GtkListBoxRow*) _tmp4_);
#line 262 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp5_ = next;
#line 262 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_emit (self, drag_list_signals[DRAG_LIST_ROW_SELECTED_SIGNAL], 0, _tmp5_);
#line 256 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (next);
#line 1070 "DragList.c"
}

void
drag_list_add_row (DragList* self,
                   GtkWidget* widget)
{
#line 265 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 265 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (widget != NULL);
#line 266 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_insert_row (self, widget, -1);
#line 1083 "DragList.c"
}

static inline void
_drag_list_add_row (DragList* self,
                    GtkWidget* widget)
{
#line 269 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 269 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (widget != NULL);
#line 270 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_drag_list_insert_row (self, widget, -1);
#line 1096 "DragList.c"
}

/**
     * Insert the widget into the this at position.
     *
     * If position is -1, or larger than the total number of items in the this, then the child will be appended to the end.
     *
     * @param widget the Widget to add
     * @param position the position to insert child in
     */
void
drag_list_insert_row (DragList* self,
                      GtkWidget* widget,
                      gint position)
{
	DragListModel* _tmp0_;
#line 281 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 281 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (widget != NULL);
#line 282 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->model;
#line 282 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp0_ == NULL) {
#line 283 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_drag_list_insert_row (self, widget, position);
#line 1123 "DragList.c"
	}
}

static void
_drag_list_insert_row (DragList* self,
                       GtkWidget* widget,
                       gint position)
{
	DragListRow* row = NULL;
	DragListRow* _tmp0_;
	DragListRow* _tmp1_;
	GtkListBox* _tmp4_;
	DragListRow* _tmp5_;
	GtkListBox* _tmp6_;
	GtkListBoxRow* _tmp7_;
#line 287 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 287 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (widget != NULL);
#line 288 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = _g_object_ref0 (IS_DRAG_LIST_ROW (widget) ? ((DragListRow*) widget) : NULL);
#line 288 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	row = _tmp0_;
#line 290 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = row;
#line 290 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp1_ == NULL) {
#line 1151 "DragList.c"
		DragListRow* _tmp2_;
		DragListRow* _tmp3_;
#line 291 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp2_ = drag_list_row_new ();
#line 291 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		g_object_ref_sink (_tmp2_);
#line 291 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (row);
#line 291 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		row = _tmp2_;
#line 292 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp3_ = row;
#line 292 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		drag_list_row_set_center_widget (_tmp3_, widget);
#line 1166 "DragList.c"
	}
#line 295 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp4_ = self->priv->listbox;
#line 295 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp5_ = row;
#line 295 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_list_box_insert (_tmp4_, (GtkWidget*) _tmp5_, position);
#line 296 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp6_ = self->priv->listbox;
#line 296 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp7_ = gtk_list_box_get_selected_row (_tmp6_);
#line 296 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp7_ == NULL) {
#line 1180 "DragList.c"
		GtkListBox* _tmp8_;
		DragListRow* _tmp9_;
		GtkListBox* _tmp10_;
		GtkListBoxRow* _tmp11_;
		DragListRow* _tmp12_;
#line 297 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp8_ = self->priv->listbox;
#line 297 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp9_ = row;
#line 297 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_list_box_select_row (_tmp8_, (GtkListBoxRow*) _tmp9_);
#line 298 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp10_ = self->priv->listbox;
#line 298 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp11_ = gtk_list_box_get_selected_row (_tmp10_);
#line 298 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp12_ = row;
#line 298 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_vala_assert (_tmp11_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_list_box_row_get_type (), GtkListBoxRow), "listbox.get_selected_row () == row");
#line 1200 "DragList.c"
	}
#line 287 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (row);
#line 1204 "DragList.c"
}

void
drag_list_remove_row (DragList* self,
                      DragListRow* row)
{
	DragListModel* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBoxRow* _tmp2_;
#line 302 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 302 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 303 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->model;
#line 303 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_vala_assert (_tmp0_ == NULL, "model == null");
#line 304 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = self->priv->listbox;
#line 304 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = gtk_list_box_get_selected_row (_tmp1_);
#line 304 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (G_TYPE_CHECK_INSTANCE_CAST (row, gtk_list_box_row_get_type (), GtkListBoxRow) == _tmp2_) {
#line 1228 "DragList.c"
		gint index = 0;
		GtkListBox* _tmp3_;
#line 305 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->block_row_selected = TRUE;
#line 306 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		index = gtk_list_box_row_get_index ((GtkListBoxRow*) row);
#line 307 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp3_ = self->priv->listbox;
#line 307 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_container_remove ((GtkContainer*) _tmp3_, (GtkWidget*) row);
#line 308 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		drag_list_select_closest_to (self, index);
#line 313 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (gtk_list_box_row_is_selected ((GtkListBoxRow*) row)) {
#line 314 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			gtk_list_box_row_set_selectable ((GtkListBoxRow*) row, FALSE);
#line 315 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			gtk_list_box_row_set_selectable ((GtkListBoxRow*) row, TRUE);
#line 1247 "DragList.c"
		}
#line 318 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->block_row_selected = FALSE;
#line 1251 "DragList.c"
	} else {
		GtkListBox* _tmp4_;
#line 320 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp4_ = self->priv->listbox;
#line 320 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_container_remove ((GtkContainer*) _tmp4_, (GtkWidget*) row);
#line 1258 "DragList.c"
	}
}

/**
     * Returns all rows contained in this.
     */
GList*
drag_list_get_rows (DragList* self)
{
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	GList* result;
#line 327 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = (GList*) _tmp1_;
#line 328 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 1281 "DragList.c"
}

/**
     * Moves row to index.
     *
     * @param row DragListRow to be moved
     * @param index the index to move the row to
     */
void
drag_list_move_row (DragList* self,
                    DragListRow* row,
                    gint index)
{
	GtkListBox* row_parent = NULL;
	GtkContainer* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
#line 337 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 337 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 338 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) row);
#line 338 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_list_box_get_type ()) ? ((GtkListBox*) _tmp0_) : NULL);
#line 338 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	row_parent = _tmp1_;
#line 340 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = row_parent;
#line 340 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = self->priv->listbox;
#line 340 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp2_ == _tmp3_) {
#line 341 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_drag_list_move_row (self, row, index, FALSE);
#line 1318 "DragList.c"
	}
#line 337 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (row_parent);
#line 1322 "DragList.c"
}

static void
_drag_list_move_row (DragList* self,
                     DragListRow* row,
                     gint index,
                     gboolean relative)
{
	gint old_index = 0;
#line 345 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 345 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 346 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	old_index = gtk_list_box_row_get_index ((GtkListBoxRow*) row);
#line 347 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (old_index != index) {
#line 1340 "DragList.c"
		gboolean _tmp0_ = FALSE;
		GtkListBox* _tmp2_;
		GtkListBox* _tmp3_;
		DragListModel* _tmp4_;
#line 348 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (relative) {
#line 348 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp0_ = index > old_index;
#line 1349 "DragList.c"
		} else {
#line 348 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp0_ = FALSE;
#line 1353 "DragList.c"
		}
#line 348 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (_tmp0_) {
#line 1357 "DragList.c"
			gint _tmp1_;
#line 349 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp1_ = index;
#line 349 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			index = _tmp1_ - 1;
#line 1363 "DragList.c"
		}
#line 351 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp2_ = self->priv->listbox;
#line 351 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_container_remove ((GtkContainer*) _tmp2_, (GtkWidget*) row);
#line 352 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp3_ = self->priv->listbox;
#line 352 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_list_box_insert (_tmp3_, (GtkWidget*) row, index);
#line 353 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp4_ = self->model;
#line 353 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (_tmp4_ != NULL) {
#line 1377 "DragList.c"
			DragListModel* _tmp6_;
#line 354 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			if (index < 0) {
#line 1381 "DragList.c"
				DragListModel* _tmp5_;
#line 355 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				_tmp5_ = self->model;
#line 355 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				index = ((gint) drag_list_model_get_n_items (_tmp5_)) - 1;
#line 1387 "DragList.c"
			}
#line 357 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp6_ = self->model;
#line 357 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			drag_list_model_move_item (_tmp6_, (guint) old_index, (guint) index);
#line 1393 "DragList.c"
		}
	}
}

/**
     * Gets the n-th child in the list.
     *
     * If @index is negative or larger than the number of items in the list,
     * null is returned.
     *
     * @param index the index of the row
     */
DragListRow*
drag_list_get_row_at_index (DragList* self,
                            gint index)
{
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	DragListRow* _tmp2_;
	DragListRow* result;
#line 370 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 371 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 371 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = gtk_list_box_get_row_at_index (_tmp0_, index);
#line 371 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DRAG_LIST_ROW, DragListRow));
#line 371 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = _tmp2_;
#line 371 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 1426 "DragList.c"
}

/**
     * By setting a filter function on the this one can decide dynamically which
     * of the rows to show.
     *
     * For instance, to implement a search function on a list that filters the
     * original list to only show the matching rows.
     *
     * The filter_func will be called for each row after the call, and it will
     * continue to be called each time a row changes (via changed) or when
     * invalidate_filter is called.
     *
     * Unlike with Gtk.Listbox, filtering is supported when a model is bound to
     * a DragList.
     *
     * @param filter_func callback that lets you filter which rows to show
     */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return _data2_;
#line 1452 "DragList.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1462 "DragList.c"
		DragList* self;
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self = _data2_->self;
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (self);
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		g_slice_free (Block2Data, _data2_);
#line 1470 "DragList.c"
	}
}

static gboolean
__lambda8_ (Block2Data* _data2_,
            GtkListBoxRow* row)
{
	DragList* self;
	gboolean result;
#line 391 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self = _data2_->self;
#line 391 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (row != NULL, FALSE);
#line 392 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = _data2_->filter_func (G_TYPE_CHECK_INSTANCE_CAST (row, TYPE_DRAG_LIST_ROW, DragListRow), _data2_->filter_func_target);
#line 392 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 1488 "DragList.c"
}

static gboolean
___lambda8__gtk_list_box_filter_func (GtkListBoxRow* row,
                                      gpointer self)
{
	gboolean result;
	result = __lambda8_ (self, row);
#line 391 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 1499 "DragList.c"
}

void
drag_list_set_filter_func (DragList* self,
                           DragListFilterFunc filter_func,
                           gpointer filter_func_target)
{
	Block2Data* _data2_;
	GtkListBox* _tmp0_;
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_data2_->_ref_count_ = 1;
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_data2_->self = g_object_ref (self);
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_data2_->filter_func = filter_func;
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_data2_->filter_func_target = filter_func_target;
#line 391 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 391 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_list_box_set_filter_func (_tmp0_, ___lambda8__gtk_list_box_filter_func, block2_data_ref (_data2_), block2_data_unref);
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	block2_data_unref (_data2_);
#line 390 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_data2_ = NULL;
#line 1529 "DragList.c"
}

/**
     * Update the filtering for all rows.
     *
     * Call this when result of the filter function on the this is changed due
     * to an external factor. For instance, this would be used if the filter
     * function just looked for a specific search string and the entry with the
     * search string has changed.
     */
void
drag_list_invalidate_filter (DragList* self)
{
	GtkListBox* _tmp0_;
#line 404 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 405 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 405 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_list_box_invalidate_filter (_tmp0_);
#line 1550 "DragList.c"
}

/**
     * Used to clamp the drag input to the area filled by the current rows to
     * make highlighting easier.
     *
     * Also sets drag_row_range to the y coordinates that would cause no change
     * when a row is dropped at those positions.
     */
static void
drag_list_set_ranges (DragList* self)
{
	IntRange _tmp0_ = {0};
	IntRange _tmp1_ = {0};
	IntRange _tmp2_ = {0};
	gint last_index = 0;
	GtkListBox* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	gint _tmp6_;
	DragListRow* first = NULL;
	DragListRow* _tmp7_;
	DragListRow* last = NULL;
	DragListRow* _tmp8_;
	GtkAllocation alloc = {0};
	DragListRow* _tmp9_;
	GtkAllocation _tmp10_ = {0};
	GtkAllocation _tmp11_;
	DragListRow* _tmp12_;
	GtkAllocation _tmp13_ = {0};
	GtkAllocation _tmp14_;
	GtkAllocation _tmp15_;
#line 415 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 416 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (self->priv->ranges_set) {
#line 417 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		return;
#line 1589 "DragList.c"
	}
#line 419 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_.min = 0;
#line 419 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_.max = -1;
#line 419 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->input_range = _tmp0_;
#line 420 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_.min = 0;
#line 420 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_.max = -1;
#line 420 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->current_hover_range = _tmp1_;
#line 421 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_.min = 0;
#line 421 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_.max = -1;
#line 421 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->drag_row_range = _tmp2_;
#line 423 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = self->priv->listbox;
#line 423 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp4_ = gtk_container_get_children ((GtkContainer*) _tmp3_);
#line 423 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp5_ = _tmp4_;
#line 423 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp6_ = ((gint) g_list_length (_tmp5_)) - 1;
#line 423 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
#line 423 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	last_index = _tmp6_;
#line 424 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp7_ = drag_list_get_row_at_index (self, 0);
#line 424 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	first = _tmp7_;
#line 425 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp8_ = drag_list_get_row_at_index (self, last_index);
#line 425 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	last = _tmp8_;
#line 428 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp9_ = first;
#line 428 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp9_, &_tmp10_);
#line 428 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	alloc = _tmp10_;
#line 429 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp11_ = alloc;
#line 429 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->input_range.min = _tmp11_.y + 1;
#line 430 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp12_ = last;
#line 430 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp12_, &_tmp13_);
#line 430 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	alloc = _tmp13_;
#line 431 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp14_ = alloc;
#line 431 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp15_ = alloc;
#line 431 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->input_range.max = (_tmp14_.y + _tmp15_.height) - 1;
#line 433 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_set_drag_row_range (self);
#line 434 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->ranges_set = TRUE;
#line 415 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (last);
#line 415 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (first);
#line 1659 "DragList.c"
}

static void
drag_list_set_drag_row_range (DragList* self)
{
	DragListRow* _tmp0_;
	gint drag_row_index = 0;
	DragListRow* _tmp1_;
	GtkAllocation alloc = {0};
	DragListRow* _tmp2_;
	GtkAllocation _tmp3_ = {0};
	GtkListBoxRow* next_row = NULL;
	GtkListBox* _tmp7_;
	GtkListBoxRow* _tmp8_;
	GtkListBoxRow* _tmp9_;
	GtkListBoxRow* _tmp10_;
#line 437 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 438 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->drag_row;
#line 438 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp0_ == NULL) {
#line 439 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		return;
#line 1684 "DragList.c"
	}
#line 442 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = self->drag_row;
#line 442 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_row_index = gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp1_);
#line 444 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = self->drag_row;
#line 444 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp2_, &_tmp3_);
#line 444 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	alloc = _tmp3_;
#line 446 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (drag_row_index >= 1) {
#line 1698 "DragList.c"
		GtkListBox* _tmp4_;
		GtkListBoxRow* _tmp5_;
#line 447 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp4_ = self->priv->listbox;
#line 447 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp5_ = gtk_list_box_get_row_at_index (_tmp4_, drag_row_index - 1);
#line 447 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->drag_row_range.min = drag_list_get_widget_middle (self, (GtkWidget*) _tmp5_);
#line 1707 "DragList.c"
	} else {
		GtkAllocation _tmp6_;
#line 451 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp6_ = alloc;
#line 451 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->drag_row_range.min = _tmp6_.y;
#line 1714 "DragList.c"
	}
#line 453 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp7_ = self->priv->listbox;
#line 453 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp8_ = gtk_list_box_get_row_at_index (_tmp7_, drag_row_index + 1);
#line 453 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 453 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	next_row = _tmp9_;
#line 454 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp10_ = next_row;
#line 454 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp10_ != NULL) {
#line 1728 "DragList.c"
		GtkListBoxRow* _tmp11_;
#line 455 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp11_ = next_row;
#line 455 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->drag_row_range.max = drag_list_get_widget_middle (self, (GtkWidget*) _tmp11_);
#line 1734 "DragList.c"
	} else {
		GtkAllocation _tmp12_;
		GtkAllocation _tmp13_;
#line 457 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp12_ = alloc;
#line 457 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp13_ = alloc;
#line 457 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->drag_row_range.max = _tmp12_.y + _tmp13_.height;
#line 1744 "DragList.c"
	}
#line 437 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (next_row);
#line 1748 "DragList.c"
}

static gint
drag_list_get_widget_middle (DragList* self,
                             GtkWidget* widget)
{
	GtkAllocation alloc = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
	gint result;
#line 461 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 461 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (widget != NULL, 0);
#line 464 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_widget_get_allocation (widget, &_tmp0_);
#line 464 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	alloc = _tmp0_;
#line 465 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = alloc;
#line 465 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = alloc;
#line 465 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = _tmp1_.y + (_tmp2_.height / 2);
#line 465 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 1776 "DragList.c"
}

static gboolean
_drag_list_scroll_gsource_func (gpointer self)
{
	gboolean result;
	result = drag_list_scroll ((DragList*) self);
#line 482 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 1786 "DragList.c"
}

static gboolean
drag_list_on_list_drag_motion (DragList* self,
                               GdkDragContext* context,
                               gint x,
                               gint y,
                               guint time_)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 468 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 468 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 471 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_set_ranges (self);
#line 472 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	y = int_range_clamp (&self->priv->input_range, y);
#line 473 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (!int_range_contains (&self->priv->current_hover_range, y)) {
#line 474 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		drag_list_remove_hover_style (self);
#line 475 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		drag_list_set_hover_rows (self, y);
#line 476 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		drag_list_add_hover_style (self);
#line 1814 "DragList.c"
	}
#line 479 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_check_scroll (self, y);
#line 480 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (self->priv->should_scroll) {
#line 480 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp0_ = !self->priv->scrolling;
#line 1822 "DragList.c"
	} else {
#line 480 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp0_ = FALSE;
#line 1826 "DragList.c"
	}
#line 480 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp0_) {
#line 481 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->scrolling = TRUE;
#line 482 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) DRAG_LIST_SCROLL_DELAY, _drag_list_scroll_gsource_func, g_object_ref (self), g_object_unref);
#line 1834 "DragList.c"
	}
#line 485 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = TRUE;
#line 485 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 1840 "DragList.c"
}

/**
     * Sets current_hover_range to the range of y values that would give the
     * same result as the current y and sets hover_row_top and hover_row_bottom
     * to the rows the dragrow would be inserted between.
     */
static void
drag_list_set_hover_rows (DragList* self,
                          gint y)
{
#line 493 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 494 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (int_range_contains (&self->priv->drag_row_range, y)) {
#line 495 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		drag_list_set_hover_rows_deadzone (self);
#line 1858 "DragList.c"
	} else {
#line 497 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		drag_list_set_hover_rows_from_y (self, y);
#line 1862 "DragList.c"
	}
}

static void
drag_list_set_hover_rows_deadzone (DragList* self)
{
	IntRange _tmp0_;
#line 501 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 502 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_bottom);
#line 502 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->hover_row_bottom = NULL;
#line 503 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_top);
#line 503 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->hover_row_top = NULL;
#line 504 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->drag_row_range;
#line 504 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->current_hover_range = _tmp0_;
#line 1884 "DragList.c"
}

static void
drag_list_set_hover_rows_from_y (DragList* self,
                                 gint y)
{
	DragListRow* row = NULL;
	GtkListBox* _tmp0_;
	GtkListBoxRow* _tmp1_;
	DragListRow* _tmp2_;
	gint hover_row_middle = 0;
	DragListRow* _tmp3_;
#line 507 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 508 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 508 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = gtk_list_box_get_row_at_y (_tmp0_, y);
#line 508 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DRAG_LIST_ROW, DragListRow));
#line 508 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	row = _tmp2_;
#line 509 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = row;
#line 509 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	hover_row_middle = drag_list_get_widget_middle (self, (GtkWidget*) _tmp3_);
#line 511 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (y < hover_row_middle) {
#line 1913 "DragList.c"
		DragListRow* _tmp4_;
		DragListRow* _tmp5_;
		DragListRow* _tmp6_;
		DragListRow* _tmp7_;
		DragListRow* _tmp8_;
#line 512 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp4_ = row;
#line 512 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 512 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (self->priv->hover_row_bottom);
#line 512 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->hover_row_bottom = _tmp5_;
#line 513 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp6_ = row;
#line 513 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp7_ = drag_list_get_row_at_index (self, gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp6_) - 1);
#line 513 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (self->priv->hover_row_top);
#line 513 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->hover_row_top = _tmp7_;
#line 514 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->current_hover_range.max = hover_row_middle;
#line 515 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp8_ = self->priv->hover_row_top;
#line 515 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (_tmp8_ != NULL) {
#line 1941 "DragList.c"
			DragListRow* _tmp9_;
#line 516 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp9_ = self->priv->hover_row_top;
#line 516 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			self->priv->current_hover_range.min = drag_list_get_widget_middle (self, (GtkWidget*) _tmp9_);
#line 1947 "DragList.c"
		} else {
			IntRange _tmp10_;
#line 518 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp10_ = self->priv->input_range;
#line 518 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			self->priv->current_hover_range.min = _tmp10_.min;
#line 1954 "DragList.c"
		}
	} else {
		DragListRow* _tmp11_;
		DragListRow* _tmp12_;
		DragListRow* _tmp13_;
		DragListRow* _tmp14_;
		DragListRow* _tmp15_;
#line 521 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp11_ = row;
#line 521 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 521 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (self->priv->hover_row_top);
#line 521 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->hover_row_top = _tmp12_;
#line 522 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp13_ = row;
#line 522 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp14_ = drag_list_get_row_at_index (self, gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp13_) + 1);
#line 522 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (self->priv->hover_row_bottom);
#line 522 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->hover_row_bottom = _tmp14_;
#line 523 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->current_hover_range.min = hover_row_middle;
#line 524 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp15_ = self->priv->hover_row_bottom;
#line 524 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (_tmp15_ != NULL) {
#line 1984 "DragList.c"
			DragListRow* _tmp16_;
#line 525 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp16_ = self->priv->hover_row_bottom;
#line 525 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			self->priv->current_hover_range.max = drag_list_get_widget_middle (self, (GtkWidget*) _tmp16_);
#line 1990 "DragList.c"
		} else {
			IntRange _tmp17_;
#line 527 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp17_ = self->priv->input_range;
#line 527 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			self->priv->current_hover_range.max = _tmp17_.max;
#line 1997 "DragList.c"
		}
	}
#line 507 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (row);
#line 2002 "DragList.c"
}

static void
drag_list_remove_hover_style (DragList* self)
{
	DragListRow* _tmp0_;
	DragListRow* _tmp3_;
#line 532 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 533 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->hover_row_top;
#line 533 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 2016 "DragList.c"
		DragListRow* _tmp1_;
		GtkStyleContext* _tmp2_;
#line 534 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp1_ = self->priv->hover_row_top;
#line 534 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 534 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_style_context_remove_class (_tmp2_, "drag-hover-top");
#line 2025 "DragList.c"
	}
#line 536 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = self->priv->hover_row_bottom;
#line 536 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp3_ != NULL) {
#line 2031 "DragList.c"
		DragListRow* _tmp4_;
		GtkStyleContext* _tmp5_;
#line 537 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp4_ = self->priv->hover_row_bottom;
#line 537 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 537 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_style_context_remove_class (_tmp5_, "drag-hover-bottom");
#line 2040 "DragList.c"
	}
}

static void
drag_list_add_hover_style (DragList* self)
{
	DragListRow* _tmp0_;
	DragListRow* _tmp3_;
#line 541 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 542 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->hover_row_top;
#line 542 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 2055 "DragList.c"
		DragListRow* _tmp1_;
		GtkStyleContext* _tmp2_;
#line 543 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp1_ = self->priv->hover_row_top;
#line 543 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 543 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_style_context_add_class (_tmp2_, "drag-hover-top");
#line 2064 "DragList.c"
	}
#line 545 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = self->priv->hover_row_bottom;
#line 545 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp3_ != NULL) {
#line 2070 "DragList.c"
		DragListRow* _tmp4_;
		GtkStyleContext* _tmp5_;
#line 546 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp4_ = self->priv->hover_row_bottom;
#line 546 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 546 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_style_context_add_class (_tmp5_, "drag-hover-bottom");
#line 2079 "DragList.c"
	}
}

static void
drag_list_on_list_drag_leave (DragList* self,
                              GdkDragContext* context,
                              guint time_)
{
#line 550 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 550 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (context != NULL);
#line 551 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->should_scroll = FALSE;
#line 552 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->ranges_set = FALSE;
#line 553 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_remove_hover_style (self);
#line 2098 "DragList.c"
}

static void
drag_list_check_scroll (DragList* self,
                        gint y)
{
	GtkAdjustment* adjustment = NULL;
	GtkListBox* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
	GtkAdjustment* _tmp3_;
	gdouble adjustment_min = 0.0;
	GtkAdjustment* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble adjustment_max = 0.0;
	GtkAdjustment* _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble show_min = 0.0;
	gdouble show_max = 0.0;
	GtkAdjustment* _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
#line 556 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 557 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 557 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = gtk_list_box_get_adjustment (_tmp0_);
#line 557 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 557 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	adjustment = _tmp2_;
#line 558 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = adjustment;
#line 558 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp3_ == NULL) {
#line 559 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->should_scroll = FALSE;
#line 560 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (adjustment);
#line 560 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		return;
#line 2143 "DragList.c"
	}
#line 562 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp4_ = adjustment;
#line 562 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp5_ = gtk_adjustment_get_value (_tmp4_);
#line 562 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp6_ = _tmp5_;
#line 562 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	adjustment_min = _tmp6_;
#line 563 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp7_ = adjustment;
#line 563 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp8_ = gtk_adjustment_get_page_size (_tmp7_);
#line 563 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp9_ = _tmp8_;
#line 563 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	adjustment_max = _tmp9_ + adjustment_min;
#line 564 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	show_min = MAX ((gdouble) 0, (gdouble) (y - DRAG_LIST_SCROLL_DISTANCE));
#line 565 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp10_ = adjustment;
#line 565 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp11_ = gtk_adjustment_get_upper (_tmp10_);
#line 565 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp12_ = _tmp11_;
#line 565 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	show_max = MIN (_tmp12_, (gdouble) (y + DRAG_LIST_SCROLL_DISTANCE));
#line 566 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (adjustment_min > show_min) {
#line 567 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->should_scroll = TRUE;
#line 568 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->scroll_up = TRUE;
#line 2177 "DragList.c"
	} else {
#line 569 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (adjustment_max < show_max) {
#line 570 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			self->priv->should_scroll = TRUE;
#line 571 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			self->priv->scroll_up = FALSE;
#line 2185 "DragList.c"
		} else {
#line 573 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			self->priv->should_scroll = FALSE;
#line 2189 "DragList.c"
		}
	}
#line 556 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (adjustment);
#line 2194 "DragList.c"
}

static gboolean
drag_list_scroll (DragList* self)
{
	GtkAdjustment* adjustment = NULL;
	GtkListBox* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
	gboolean result;
#line 577 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 578 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 578 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = gtk_list_box_get_adjustment (_tmp0_);
#line 578 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 578 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	adjustment = _tmp2_;
#line 579 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (self->priv->should_scroll) {
#line 580 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (self->priv->scroll_up) {
#line 2219 "DragList.c"
			GtkAdjustment* _tmp3_;
			GtkAdjustment* _tmp4_;
			gdouble _tmp5_;
			gdouble _tmp6_;
#line 581 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp3_ = adjustment;
#line 581 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp4_ = adjustment;
#line 581 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp5_ = gtk_adjustment_get_value (_tmp4_);
#line 581 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp6_ = _tmp5_;
#line 581 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			gtk_adjustment_set_value (_tmp4_, _tmp6_ - DRAG_LIST_SCROLL_STEP_SIZE);
#line 2234 "DragList.c"
		} else {
			GtkAdjustment* _tmp7_;
			GtkAdjustment* _tmp8_;
			gdouble _tmp9_;
			gdouble _tmp10_;
#line 583 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp7_ = adjustment;
#line 583 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp8_ = adjustment;
#line 583 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp9_ = gtk_adjustment_get_value (_tmp8_);
#line 583 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp10_ = _tmp9_;
#line 583 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			gtk_adjustment_set_value (_tmp8_, _tmp10_ + DRAG_LIST_SCROLL_STEP_SIZE);
#line 2250 "DragList.c"
		}
	} else {
#line 586 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		self->priv->scrolling = FALSE;
#line 2255 "DragList.c"
	}
#line 588 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = self->priv->should_scroll;
#line 588 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (adjustment);
#line 588 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 2263 "DragList.c"
}

static void
drag_list_on_list_drag_data_received (DragList* self,
                                      GdkDragContext* context,
                                      gint x,
                                      gint y,
                                      GtkSelectionData* selection_data,
                                      guint info,
                                      guint time_)
{
	DragListRow* row = NULL;
	gint index = 0;
	DragListRow* _tmp0_;
	gboolean _tmp6_ = FALSE;
#line 591 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 591 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (context != NULL);
#line 591 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (selection_data != NULL);
#line 597 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	index = -1;
#line 598 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_remove_hover_style (self);
#line 599 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->hover_row_bottom;
#line 599 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 2293 "DragList.c"
		DragListRow* _tmp1_;
#line 600 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp1_ = self->priv->hover_row_bottom;
#line 600 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		index = gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp1_);
#line 2299 "DragList.c"
	} else {
		DragListRow* _tmp2_;
#line 601 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp2_ = self->priv->hover_row_top;
#line 601 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (_tmp2_ != NULL) {
#line 2306 "DragList.c"
			DragListRow* _tmp3_;
#line 602 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp3_ = self->priv->hover_row_top;
#line 602 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			index = gtk_list_box_row_get_index ((GtkListBoxRow*) _tmp3_) + 1;
#line 2312 "DragList.c"
		} else {
			GtkListBox* _tmp4_;
			GtkListBoxRow* _tmp5_;
#line 603 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp4_ = self->priv->listbox;
#line 603 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp5_ = gtk_list_box_get_row_at_index (_tmp4_, 0);
#line 603 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			if (_tmp5_ == NULL) {
#line 604 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
				index = 0;
#line 2324 "DragList.c"
			}
		}
	}
#line 606 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (index >= 0) {
#line 2330 "DragList.c"
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 606 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp7_ = gdk_atom_name (gtk_selection_data_get_data_type (selection_data));
#line 606 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp8_ = _tmp7_;
#line 606 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp6_ = g_strcmp0 (_tmp8_, "DRAG_LIST_ROW") == 0;
#line 606 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_free0 (_tmp8_);
#line 2341 "DragList.c"
	} else {
#line 606 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp6_ = FALSE;
#line 2345 "DragList.c"
	}
#line 606 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp6_) {
#line 2349 "DragList.c"
		guint8* _tmp9_;
		DragListRow* _tmp10_;
		DragListRow* _tmp11_;
		DragListRow* _tmp12_;
#line 607 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp9_ = gtk_selection_data_get_data (selection_data);
#line 607 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp10_ = ((DragListRow**) _tmp9_)[0];
#line 607 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 607 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (row);
#line 607 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		row = _tmp11_;
#line 608 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp12_ = row;
#line 608 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		drag_list_drag_insert_row (self, _tmp12_, index);
#line 2368 "DragList.c"
	}
#line 610 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->drag_row);
#line 610 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->drag_row = NULL;
#line 611 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_top);
#line 611 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->hover_row_top = NULL;
#line 612 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_bottom);
#line 612 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->hover_row_bottom = NULL;
#line 613 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->ranges_set = FALSE;
#line 591 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (row);
#line 2386 "DragList.c"
}

static void
drag_list_drag_insert_row (DragList* self,
                           DragListRow* row,
                           gint index)
{
	DragList* row_draglist = NULL;
	DragList* _tmp0_;
	DragList* _tmp1_;
#line 616 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 616 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 617 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = drag_list_row_get_drag_list_box (row);
#line 617 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	row_draglist = _tmp0_;
#line 619 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = row_draglist;
#line 619 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp1_ == self) {
#line 620 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_drag_list_move_row (self, row, index, TRUE);
#line 2411 "DragList.c"
	} else {
		gboolean _tmp2_ = FALSE;
		DragListModel* _tmp3_;
#line 622 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp3_ = self->model;
#line 622 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (_tmp3_ == NULL) {
#line 2419 "DragList.c"
			DragList* _tmp4_;
			DragListModel* _tmp5_;
#line 622 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp4_ = row_draglist;
#line 622 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp5_ = _tmp4_->model;
#line 622 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp2_ = _tmp5_ == NULL;
#line 2428 "DragList.c"
		} else {
#line 622 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp2_ = FALSE;
#line 2432 "DragList.c"
		}
#line 622 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		if (_tmp2_) {
#line 2436 "DragList.c"
			GtkContainer* _tmp6_;
			GtkListBox* _tmp7_;
#line 623 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp6_ = gtk_widget_get_parent ((GtkWidget*) row);
#line 623 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			gtk_container_remove (_tmp6_, (GtkWidget*) row);
#line 624 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			_tmp7_ = self->priv->listbox;
#line 624 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			gtk_list_box_insert (_tmp7_, (GtkWidget*) row, index);
#line 2447 "DragList.c"
		} else {
#line 626 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
			g_signal_emit (self, drag_list_signals[DRAG_LIST_ROW_RECEIVED_WITH_MODEL_SIGNAL], 0, row, index);
#line 2451 "DragList.c"
		}
	}
#line 616 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (row_draglist);
#line 2456 "DragList.c"
}

GtkAdjustment*
drag_list_get_vadjustment (DragList* self)
{
	GtkAdjustment* result;
	GtkListBox* _tmp0_;
	GtkAdjustment* _tmp1_;
#line 56 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 57 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = gtk_list_box_get_adjustment (_tmp0_);
#line 57 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = _tmp1_;
#line 57 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 2475 "DragList.c"
}

void
drag_list_set_vadjustment (DragList* self,
                           GtkAdjustment* value)
{
	GtkListBox* _tmp0_;
#line 59 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 60 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 60 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_list_box_set_adjustment (_tmp0_, value);
#line 59 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_object_notify_by_pspec ((GObject *) self, drag_list_properties[DRAG_LIST_VADJUSTMENT_PROPERTY]);
#line 2491 "DragList.c"
}

static void
drag_list_real_activate_cursor_row (DragList* self)
{
	GtkListBox* _tmp0_;
#line 68 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 68 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_emit_by_name (_tmp0_, "activate-cursor-row");
#line 2502 "DragList.c"
}

static void
drag_list_real_row_activated (DragList* self,
                              DragListRow* row)
{
#line 75 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 76 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return;
#line 2513 "DragList.c"
}

static void
drag_list_real_move_cursor (DragList* self,
                            GtkMovementStep step,
                            gint count)
{
	GtkListBox* _tmp0_;
#line 87 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->internal_signal = TRUE;
#line 88 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->listbox;
#line 88 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_emit_by_name (_tmp0_, "move-cursor", step, count);
#line 2528 "DragList.c"
}

static void
g_cclosure_user_marshal_VOID__ENUM_INT (GClosure * closure,
                                        GValue * return_value,
                                        guint n_param_values,
                                        const GValue * param_values,
                                        gpointer invocation_hint,
                                        gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__ENUM_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (n_param_values == 3);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		data1 = closure->data;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		data2 = param_values->data[0].v_pointer;
#line 2553 "DragList.c"
	} else {
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		data1 = param_values->data[0].v_pointer;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		data2 = closure->data;
#line 2559 "DragList.c"
	}
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	callback = (GMarshalFunc_VOID__ENUM_INT) (marshal_data ? marshal_data : cc->callback);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 2565 "DragList.c"
}

static void
drag_list_real_row_selected (DragList* self,
                             DragListRow* row)
{
#line 102 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return;
#line 2574 "DragList.c"
}

static void
drag_list_real_row_received_with_model (DragList* self,
                                        DragListRow* row,
                                        gint index)
{
#line 118 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (row != NULL);
#line 119 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return;
#line 2586 "DragList.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (n_param_values == 3);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		data1 = closure->data;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		data2 = param_values->data[0].v_pointer;
#line 2611 "DragList.c"
	} else {
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		data1 = param_values->data[0].v_pointer;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		data2 = closure->data;
#line 2617 "DragList.c"
	}
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT) (marshal_data ? marshal_data : cc->callback);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 2623 "DragList.c"
}

static void
drag_list_class_init (DragListClass * klass,
                      gpointer klass_data)
{
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_parent_class = g_type_class_peek_parent (klass);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_type_class_adjust_private_offset (klass, &DragList_private_offset);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	((DragListClass *) klass)->activate_cursor_row = drag_list_real_activate_cursor_row;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	((DragListClass *) klass)->row_activated = drag_list_real_row_activated;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	((DragListClass *) klass)->move_cursor = drag_list_real_move_cursor;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	((DragListClass *) klass)->row_selected = drag_list_real_row_selected;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	((DragListClass *) klass)->row_received_with_model = drag_list_real_row_received_with_model;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_drag_list_get_property;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_drag_list_set_property;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	G_OBJECT_CLASS (klass)->finalize = drag_list_finalize;
#line 2650 "DragList.c"
	/**
	     * Adjustment used for scrolling.
	     */
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRAG_LIST_VADJUSTMENT_PROPERTY, drag_list_properties[DRAG_LIST_VADJUSTMENT_PROPERTY] = g_param_spec_object ("vadjustment", "vadjustment", "vadjustment", gtk_adjustment_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2656 "DragList.c"
	/**
	     * Activates the currently selected row.
	     */
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_signals[DRAG_LIST_ACTIVATE_CURSOR_ROW_SIGNAL] = g_signal_new ("activate-cursor-row", TYPE_DRAG_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DragListClass, activate_cursor_row), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2662 "DragList.c"
	/**
	     * The row_activated signal is emitted when a row has been activated by the.
	     * user.
	     */
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_signals[DRAG_LIST_ROW_ACTIVATED_SIGNAL] = g_signal_new ("row-activated", TYPE_DRAG_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DragListClass, row_activated), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DRAG_LIST_ROW);
#line 2669 "DragList.c"
	/**
	     * Selects the row count*step positions away from the currently selected row.
	     */
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_signals[DRAG_LIST_MOVE_CURSOR_SIGNAL] = g_signal_new ("move-cursor", TYPE_DRAG_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DragListClass, move_cursor), NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_INT, G_TYPE_NONE, 2, gtk_movement_step_get_type (), G_TYPE_INT);
#line 2675 "DragList.c"
	/**
	     * The row_selected signal is emitted when a new row is selected, or null.
	     * when the last row is removed.
	     */
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_signals[DRAG_LIST_ROW_SELECTED_SIGNAL] = g_signal_new ("row-selected", TYPE_DRAG_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DragListClass, row_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DRAG_LIST_ROW);
#line 2682 "DragList.c"
	/**
	     * The row_received_with_model is emitted when this receives a row when a
	     * model is bound to this or to the current parent DragList of the row.
	     *
	     * @param row Row that was received
	     * @param index index at which it would have been inserted in
	     */
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_signals[DRAG_LIST_ROW_RECEIVED_WITH_MODEL_SIGNAL] = g_signal_new ("row-received-with-model", TYPE_DRAG_LIST, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DragListClass, row_received_with_model), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT, G_TYPE_NONE, 2, TYPE_DRAG_LIST_ROW, G_TYPE_INT);
#line 2692 "DragList.c"
}

static void
drag_list_instance_init (DragList * self,
                         gpointer klass)
{
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv = drag_list_get_instance_private (self);
#line 34 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->should_scroll = FALSE;
#line 35 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->scrolling = FALSE;
#line 38 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->ranges_set = FALSE;
#line 2707 "DragList.c"
}

static void
drag_list_finalize (GObject * obj)
{
	DragList * self;
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DRAG_LIST, DragList);
#line 26 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->listbox);
#line 28 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->model);
#line 29 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	(self->priv->create_widget_func_target_destroy_notify == NULL) ? NULL : (self->priv->create_widget_func_target_destroy_notify (self->priv->create_widget_func_target), NULL);
#line 29 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->create_widget_func = NULL;
#line 29 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->create_widget_func_target = NULL;
#line 29 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->create_widget_func_target_destroy_notify = NULL;
#line 31 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_top);
#line 32 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->hover_row_bottom);
#line 33 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->drag_row);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	G_OBJECT_CLASS (drag_list_parent_class)->finalize (obj);
#line 2736 "DragList.c"
}

/**
 * A Gtk.ListBox based widget with drag and drop support.
 *
 * If this contains any rows exactly one will be selected at all times.
 *
 * Row headers are not supported.
 */
static GType
drag_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DragListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drag_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DragList), 0, (GInstanceInitFunc) drag_list_instance_init, NULL };
	GType drag_list_type_id;
	drag_list_type_id = g_type_register_static (gtk_bin_get_type (), "DragList", &g_define_type_info, 0);
	DragList_private_offset = g_type_add_instance_private (drag_list_type_id, sizeof (DragListPrivate));
	return drag_list_type_id;
}

GType
drag_list_get_type (void)
{
	static volatile gsize drag_list_type_id__once = 0;
	if (g_once_init_enter (&drag_list_type_id__once)) {
		GType drag_list_type_id;
		drag_list_type_id = drag_list_get_type_once ();
		g_once_init_leave (&drag_list_type_id__once, drag_list_type_id);
	}
	return drag_list_type_id__once;
}

static void
_vala_drag_list_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	DragList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DRAG_LIST, DragList);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	switch (property_id) {
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		case DRAG_LIST_VADJUSTMENT_PROPERTY:
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		g_value_set_object (value, drag_list_get_vadjustment (self));
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		break;
#line 2784 "DragList.c"
		default:
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		break;
#line 2790 "DragList.c"
	}
}

static void
_vala_drag_list_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	DragList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DRAG_LIST, DragList);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	switch (property_id) {
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		case DRAG_LIST_VADJUSTMENT_PROPERTY:
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		drag_list_set_vadjustment (self, g_value_get_object (value));
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		break;
#line 2810 "DragList.c"
		default:
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		break;
#line 2816 "DragList.c"
	}
}

inline gboolean
int_range_contains (IntRange *self,
                    gint val)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 642 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (val >= (*self).min) {
#line 642 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp0_ = val <= (*self).max;
#line 2830 "DragList.c"
	} else {
#line 642 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp0_ = FALSE;
#line 2834 "DragList.c"
	}
#line 642 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = _tmp0_;
#line 642 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 2840 "DragList.c"
}

inline gint
int_range_clamp (IntRange *self,
                 gint val)
{
	gint result;
#line 643 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = CLAMP (val, (*self).min, (*self).max);
#line 643 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 2852 "DragList.c"
}

IntRange*
int_range_dup (const IntRange* self)
{
	IntRange* dup;
#line 639 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	dup = g_new0 (IntRange, 1);
#line 639 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	memcpy (dup, self, sizeof (IntRange));
#line 639 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return dup;
#line 2865 "DragList.c"
}

void
int_range_free (IntRange* self)
{
#line 639 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_free (self);
#line 2873 "DragList.c"
}

static GType
int_range_get_type_once (void)
{
	GType int_range_type_id;
	int_range_type_id = g_boxed_type_register_static ("IntRange", (GBoxedCopyFunc) int_range_dup, (GBoxedFreeFunc) int_range_free);
	return int_range_type_id;
}

GType
int_range_get_type (void)
{
	static volatile gsize int_range_type_id__once = 0;
	if (g_once_init_enter (&int_range_type_id__once)) {
		GType int_range_type_id;
		int_range_type_id = int_range_get_type_once ();
		g_once_init_leave (&int_range_type_id__once, int_range_type_id);
	}
	return int_range_type_id__once;
}

static inline gpointer
drag_list_row_get_instance_private (DragListRow* self)
{
	return G_STRUCT_MEMBER_P (self, DragListRow_private_offset);
}

static void
_drag_list_row_handle_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                        GdkDragContext* context,
                                                        gpointer self)
{
#line 667 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_row_handle_drag_begin ((DragListRow*) self, context);
#line 2909 "DragList.c"
}

static void
_drag_list_row_handle_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              GtkSelectionData* selection_data,
                                                              guint info,
                                                              guint time_,
                                                              gpointer self)
{
#line 668 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_row_handle_drag_data_get ((DragListRow*) self, context, selection_data, info, time_);
#line 2922 "DragList.c"
}

DragListRow*
drag_list_row_construct (GType object_type)
{
	DragListRow * self = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkEventBox* _tmp4_;
	GtkImage* _tmp5_;
	GtkEventBox* _tmp6_;
	GtkImage* _tmp7_;
	GtkBox* _tmp8_;
	GtkEventBox* _tmp9_;
	GtkEventBox* _tmp10_;
	GtkEventBox* _tmp11_;
	GtkEventBox* _tmp12_;
#line 653 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self = (DragListRow*) g_object_new (object_type, NULL);
#line 654 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 5);
#line 654 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_object_ref_sink (_tmp0_);
#line 654 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->layout);
#line 654 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->layout = _tmp0_;
#line 655 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = self->priv->layout;
#line 655 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp1_, 5);
#line 656 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = self->priv->layout;
#line 656 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp2_, 5);
#line 657 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = self->priv->layout;
#line 657 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp3_);
#line 659 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp4_ = (GtkEventBox*) gtk_event_box_new ();
#line 659 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_object_ref_sink (_tmp4_);
#line 659 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->handle);
#line 659 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->handle = _tmp4_;
#line 660 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("view-list-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 660 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_object_ref_sink (_tmp5_);
#line 660 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->image);
#line 660 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->image = _tmp5_;
#line 661 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp6_ = self->priv->handle;
#line 661 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp7_ = self->priv->image;
#line 661 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 662 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp8_ = self->priv->layout;
#line 662 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp9_ = self->priv->handle;
#line 662 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_box_pack_end (_tmp8_, (GtkWidget*) _tmp9_, FALSE, TRUE, (guint) 0);
#line 664 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp10_ = self->priv->handle;
#line 664 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_drag_source_set ((GtkWidget*) _tmp10_, GDK_BUTTON1_MASK, dlb_entries, (gint) G_N_ELEMENTS (dlb_entries), GDK_ACTION_MOVE);
#line 667 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp11_ = self->priv->handle;
#line 667 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_connect_object ((GtkWidget*) _tmp11_, "drag-begin", (GCallback) _drag_list_row_handle_drag_begin_gtk_widget_drag_begin, self, 0);
#line 668 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp12_ = self->priv->handle;
#line 668 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_connect_object ((GtkWidget*) _tmp12_, "drag-data-get", (GCallback) _drag_list_row_handle_drag_data_get_gtk_widget_drag_data_get, self, 0);
#line 653 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return self;
#line 3006 "DragList.c"
}

DragListRow*
drag_list_row_new (void)
{
#line 653 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return drag_list_row_construct (TYPE_DRAG_LIST_ROW);
#line 3014 "DragList.c"
}

void
drag_list_row_set_start_widget (DragListRow* self,
                                GtkWidget* widget)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
#line 671 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 672 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->start_widget;
#line 672 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 3030 "DragList.c"
		GtkBox* _tmp1_;
		GtkWidget* _tmp2_;
#line 673 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp1_ = self->priv->layout;
#line 673 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp2_ = self->priv->start_widget;
#line 673 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_container_remove ((GtkContainer*) _tmp1_, _tmp2_);
#line 3039 "DragList.c"
	}
#line 675 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = _g_object_ref0 (widget);
#line 675 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->start_widget);
#line 675 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->start_widget = _tmp3_;
#line 676 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp4_ = self->priv->start_widget;
#line 676 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp4_ != NULL) {
#line 3051 "DragList.c"
		GtkBox* _tmp5_;
		GtkWidget* _tmp6_;
#line 677 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp5_ = self->priv->layout;
#line 677 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp6_ = self->priv->start_widget;
#line 677 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_box_pack_start (_tmp5_, _tmp6_, FALSE, TRUE, (guint) 0);
#line 3060 "DragList.c"
	}
}

GtkWidget*
drag_list_row_get_start_widget (DragListRow* self)
{
	GtkWidget* _tmp0_;
	GtkWidget* result;
#line 681 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 682 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->start_widget;
#line 682 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = _tmp0_;
#line 682 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 3077 "DragList.c"
}

void
drag_list_row_set_center_widget (DragListRow* self,
                                 GtkWidget* widget)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
#line 685 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 686 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->center_widget;
#line 686 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp0_ != NULL) {
#line 3093 "DragList.c"
		GtkBox* _tmp1_;
		GtkWidget* _tmp2_;
#line 687 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp1_ = self->priv->layout;
#line 687 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp2_ = self->priv->start_widget;
#line 687 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_container_remove ((GtkContainer*) _tmp1_, _tmp2_);
#line 3102 "DragList.c"
	}
#line 689 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = _g_object_ref0 (widget);
#line 689 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->center_widget);
#line 689 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv->center_widget = _tmp3_;
#line 690 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp4_ = self->priv->center_widget;
#line 690 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp4_ != NULL) {
#line 3114 "DragList.c"
		GtkBox* _tmp5_;
		GtkWidget* _tmp6_;
		GtkBox* _tmp7_;
		GtkWidget* _tmp8_;
#line 691 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp5_ = self->priv->layout;
#line 691 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp6_ = self->priv->center_widget;
#line 691 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_box_set_center_widget (_tmp5_, _tmp6_);
#line 692 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp7_ = self->priv->layout;
#line 692 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp8_ = self->priv->center_widget;
#line 692 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		gtk_box_set_child_packing (_tmp7_, _tmp8_, TRUE, TRUE, (guint) 0, GTK_PACK_START);
#line 3131 "DragList.c"
	}
}

GtkWidget*
drag_list_row_get_center_widget (DragListRow* self)
{
	GtkWidget* _tmp0_;
	GtkWidget* result;
#line 698 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 699 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = self->priv->center_widget;
#line 699 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = _tmp0_;
#line 699 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 3148 "DragList.c"
}

/**
     * Gets the DragList parent of this.
     */
DragList*
drag_list_row_get_drag_list_box (DragListRow* self)
{
	GtkWidget* parent = NULL;
	GtkContainer* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	DragList* result;
#line 705 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 706 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 706 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
#line 706 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	parent = _tmp1_;
#line 707 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = parent;
#line 707 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp2_ != NULL) {
#line 3174 "DragList.c"
		GtkWidget* _tmp3_;
		GtkContainer* _tmp4_;
		DragList* _tmp5_;
#line 708 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp3_ = parent;
#line 708 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp4_ = gtk_widget_get_parent (_tmp3_);
#line 708 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp5_ = _g_object_ref0 (IS_DRAG_LIST (_tmp4_) ? ((DragList*) _tmp4_) : NULL);
#line 708 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		result = _tmp5_;
#line 708 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (parent);
#line 708 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		return result;
#line 3190 "DragList.c"
	}
#line 710 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	result = NULL;
#line 710 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (parent);
#line 710 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	return result;
#line 3198 "DragList.c"
}

static void
drag_list_row_handle_drag_begin (DragListRow* self,
                                 GdkDragContext* context)
{
	DragList* draglist = NULL;
	GtkAllocation alloc = {0};
	cairo_surface_t* surface = NULL;
	cairo_t* cr = NULL;
	gint x = 0;
	gint y = 0;
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
	cairo_surface_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	cairo_t* _tmp5_;
	DragList* _tmp6_;
	DragList* _tmp7_;
	GtkStyleContext* _tmp10_;
	cairo_t* _tmp11_;
	gboolean _tmp12_ = FALSE;
	GtkStyleContext* _tmp13_;
	GtkEventBox* _tmp14_;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	cairo_surface_t* _tmp17_;
	cairo_surface_t* _tmp18_;
#line 713 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 713 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (context != NULL);
#line 720 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 720 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	alloc = _tmp0_;
#line 721 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = alloc;
#line 721 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp2_ = alloc;
#line 721 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp3_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp1_.width, _tmp2_.height);
#line 721 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_cairo_surface_destroy0 (surface);
#line 721 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	surface = _tmp3_;
#line 724 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp4_ = surface;
#line 724 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp5_ = cairo_create (_tmp4_);
#line 724 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_cairo_destroy0 (cr);
#line 724 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	cr = _tmp5_;
#line 726 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp6_ = drag_list_row_get_drag_list_box (self);
#line 726 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (draglist);
#line 726 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	draglist = _tmp6_;
#line 727 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp7_ = draglist;
#line 727 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	if (_tmp7_ != NULL) {
#line 3264 "DragList.c"
		DragList* _tmp8_;
		DragListRow* _tmp9_;
#line 728 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp8_ = draglist;
#line 728 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp9_ = _g_object_ref0 (self);
#line 728 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_g_object_unref0 (_tmp8_->drag_row);
#line 728 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
		_tmp8_->drag_row = _tmp9_;
#line 3275 "DragList.c"
	}
#line 730 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 730 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_style_context_add_class (_tmp10_, "drag-icon");
#line 731 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp11_ = cr;
#line 731 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_signal_emit_by_name ((GtkWidget*) self, "draw", _tmp11_, &_tmp12_);
#line 732 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 732 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_style_context_remove_class (_tmp13_, "drag-icon");
#line 734 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp14_ = self->priv->handle;
#line 734 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_widget_translate_coordinates ((GtkWidget*) _tmp14_, (GtkWidget*) self, 0, 0, &_tmp15_, &_tmp16_);
#line 734 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	x = _tmp15_;
#line 734 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	y = _tmp16_;
#line 735 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp17_ = surface;
#line 735 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	cairo_surface_set_device_offset (_tmp17_, (gdouble) (-x), (gdouble) (-y));
#line 736 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp18_ = surface;
#line 736 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_drag_set_icon_surface (context, _tmp18_);
#line 713 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_cairo_destroy0 (cr);
#line 713 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_cairo_surface_destroy0 (surface);
#line 713 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (draglist);
#line 3311 "DragList.c"
}

static void
drag_list_row_handle_drag_data_get (DragListRow* self,
                                    GdkDragContext* context,
                                    GtkSelectionData* selection_data,
                                    guint info,
                                    guint time_)
{
	guchar* data = NULL;
	guchar* _tmp0_;
	gint data_length1;
	gint _data_size_;
	GtkWidget* _tmp1_;
#line 739 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (self != NULL);
#line 739 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (context != NULL);
#line 739 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_return_if_fail (selection_data != NULL);
#line 743 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp0_ = g_new0 (guchar, sizeof (GtkWidget*));
#line 743 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	data = _tmp0_;
#line 743 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	data_length1 = sizeof (GtkWidget*);
#line 743 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_data_size_ = data_length1;
#line 744 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) self);
#line 744 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (((GtkWidget**) data)[0]);
#line 744 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	((GtkWidget**) data)[0] = _tmp1_;
#line 745 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	gtk_selection_data_set (selection_data, gdk_atom_intern_static_string ("DRAG_LIST_ROW"), 32, data, (gint) data_length1);
#line 739 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	data = (g_free (data), NULL);
#line 3350 "DragList.c"
}

static void
drag_list_row_class_init (DragListRowClass * klass,
                          gpointer klass_data)
{
#line 646 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	drag_list_row_parent_class = g_type_class_peek_parent (klass);
#line 646 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	g_type_class_adjust_private_offset (klass, &DragListRow_private_offset);
#line 646 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	G_OBJECT_CLASS (klass)->finalize = drag_list_row_finalize;
#line 3363 "DragList.c"
}

static void
drag_list_row_instance_init (DragListRow * self,
                             gpointer klass)
{
#line 646 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self->priv = drag_list_row_get_instance_private (self);
#line 3372 "DragList.c"
}

static void
drag_list_row_finalize (GObject * obj)
{
	DragListRow * self;
#line 646 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DRAG_LIST_ROW, DragListRow);
#line 647 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->handle);
#line 648 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->layout);
#line 649 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->image);
#line 650 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->start_widget);
#line 651 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	_g_object_unref0 (self->priv->center_widget);
#line 646 "/home/abuild/rpmbuild/BUILD/Go-For-It-1.6.3/src/view/DragList.vala"
	G_OBJECT_CLASS (drag_list_row_parent_class)->finalize (obj);
#line 3393 "DragList.c"
}

static GType
drag_list_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DragListRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drag_list_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DragListRow), 0, (GInstanceInitFunc) drag_list_row_instance_init, NULL };
	GType drag_list_row_type_id;
	drag_list_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "DragListRow", &g_define_type_info, 0);
	DragListRow_private_offset = g_type_add_instance_private (drag_list_row_type_id, sizeof (DragListRowPrivate));
	return drag_list_row_type_id;
}

GType
drag_list_row_get_type (void)
{
	static volatile gsize drag_list_row_type_id__once = 0;
	if (g_once_init_enter (&drag_list_row_type_id__once)) {
		GType drag_list_row_type_id;
		drag_list_row_type_id = drag_list_row_get_type_once ();
		g_once_init_leave (&drag_list_row_type_id__once, drag_list_row_type_id);
	}
	return drag_list_row_type_id__once;
}

